/*! JointJS v2.1.2 (2018-05-08) - JavaScript diagramming library


This Source Code Form is subject to the terms of the Mozilla Public
License, v. 2.0. If a copy of the MPL was not distributed with this
file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/
(function(root, factory) {

    if (typeof define === 'function' && define.amd) {

        // AMD. Register as an anonymous module.
        define([], factory);

    } else if (typeof exports === 'object') {

        // Node. Does not work with strict CommonJS, but
        // only CommonJS-like environments that support module.exports,
        // like Node.
        module.exports = factory();

    } else {

        // Browser globals.
        root.g = factory();
    }

}(this, function() {

var g=function(){function a(a,b){return b.unshift(null),new(Function.prototype.bind.apply(a,b))}function b(a){var b,c,d=[];for(c=arguments.length,b=1;b<c;b++)d.push(arguments[b]);if(!a)throw new Error("Missing a parent object.");var e=Object.create(a);for(c=d.length,b=0;b<c;b++){var f,g,h=d[b];for(g in h)h.hasOwnProperty(g)&&(delete e[g],f=Object.getOwnPropertyDescriptor(h,g),Object.defineProperty(e,g,f))}return e}var c={},d=Math,e=d.abs,f=d.cos,g=d.sin,h=d.sqrt,i=d.min,j=d.max,k=d.atan2,l=d.round,m=d.floor,n=d.PI,o=d.random,p=d.pow;c.bezier={curveThroughPoints:function(a){return console.warn("deprecated"),new t(q.throughPoints(a)).serialize()},getCurveControlPoints:function(a){console.warn("deprecated");var b,c=[],d=[],e=a.length-1;if(1==e)return c[0]=new u((2*a[0].x+a[1].x)/3,(2*a[0].y+a[1].y)/3),d[0]=new u(2*c[0].x-a[0].x,2*c[0].y-a[0].y),[c,d];var f=[];for(b=1;b<e-1;b++)f[b]=4*a[b].x+2*a[b+1].x;f[0]=a[0].x+2*a[1].x,f[e-1]=(8*a[e-1].x+a[e].x)/2;var g=this.getFirstControlPoints(f);for(b=1;b<e-1;++b)f[b]=4*a[b].y+2*a[b+1].y;f[0]=a[0].y+2*a[1].y,f[e-1]=(8*a[e-1].y+a[e].y)/2;var h=this.getFirstControlPoints(f);for(b=0;b<e;b++)c.push(new u(g[b],h[b])),b<e-1?d.push(new u(2*a[b+1].x-g[b+1],2*a[b+1].y-h[b+1])):d.push(new u((a[e].x+g[e-1])/2,(a[e].y+h[e-1])/2));return[c,d]},getFirstControlPoints:function(a){console.warn("deprecated");var b=a.length,c=[],d=[],e=2;c[0]=a[0]/e;for(var f=1;f<b;f++)d[f]=1/e,e=(f<b-1?4:3.5)-d[f],c[f]=(a[f]-c[f-1])/e;for(f=1;f<b;f++)c[b-f-1]-=d[b-f]*c[b-f];return c},getCurveDivider:function(a,b,c,d){console.warn("deprecated");var e=new q(a,b,c,d);return function(a){var b=e.divide(a);return[{p0:b[0].start,p1:b[0].controlPoint1,p2:b[0].controlPoint2,p3:b[0].end},{p0:b[1].start,p1:b[1].controlPoint1,p2:b[1].controlPoint2,p3:b[1].end}]}},getInversionSolver:function(a,b,c,d){console.warn("deprecated");var e=new q(a,b,c,d);return function(a){return e.closestPointT(a)}}};var q=c.Curve=function(a,b,c,d){return this instanceof q?a instanceof q?new q(a.start,a.controlPoint1,a.controlPoint2,a.end):(this.start=new u(a),this.controlPoint1=new u(b),this.controlPoint2=new u(c),void(this.end=new u(d))):new q(a,b,c,d)};q.throughPoints=function(){function a(a){var b=a.length,c=[],d=[],e=2;c[0]=a[0]/e;for(var f=1;f<b;f++)d[f]=1/e,e=(f<b-1?4:3.5)-d[f],c[f]=(a[f]-c[f-1])/e;for(f=1;f<b;f++)c[b-f-1]-=d[b-f]*c[b-f];return c}function b(b){var c,d=[],e=[],f=b.length-1;if(1==f)return d[0]=new u((2*b[0].x+b[1].x)/3,(2*b[0].y+b[1].y)/3),e[0]=new u(2*d[0].x-b[0].x,2*d[0].y-b[0].y),[d,e];var g=[];for(c=1;c<f-1;c++)g[c]=4*b[c].x+2*b[c+1].x;g[0]=b[0].x+2*b[1].x,g[f-1]=(8*b[f-1].x+b[f].x)/2;var h=a(g);for(c=1;c<f-1;++c)g[c]=4*b[c].y+2*b[c+1].y;g[0]=b[0].y+2*b[1].y,g[f-1]=(8*b[f-1].y+b[f].y)/2;var i=a(g);for(c=0;c<f;c++)d.push(new u(h[c],i[c])),c<f-1?e.push(new u(2*b[c+1].x-h[c+1],2*b[c+1].y-i[c+1])):e.push(new u((b[f].x+h[f-1])/2,(b[f].y+i[f-1])/2));return[d,e]}return function(a){if(!a||Array.isArray(a)&&a.length<2)throw new Error("At least 2 points are required");for(var c=b(a),d=[],e=c[0].length,f=0;f<e;f++){var g=new u(c[0][f].x,c[0][f].y),h=new u(c[1][f].x,c[1][f].y);d.push(new q(a[f],g,h,a[f+1]))}return d}}(),q.prototype={bbox:function(){for(var a,b,c,d,f,g,k,l,m=this.start,n=this.controlPoint1,o=this.controlPoint2,p=this.end,q=m.x,r=m.y,s=n.x,t=n.y,u=o.x,w=o.y,x=p.x,y=p.y,z=new Array,A=new Array,B=[new Array,new Array],C=0;C<2;++C)if(0===C?(b=6*q-12*s+6*u,a=-3*q+9*s-9*u+3*x,c=3*s-3*q):(b=6*r-12*t+6*w,a=-3*r+9*t-9*w+3*y,c=3*t-3*r),e(a)<1e-12){if(e(b)<1e-12)continue;d=-c/b,0<d&&d<1&&A.push(d)}else k=b*b-4*c*a,l=h(k),k<0||(f=(-b+l)/(2*a),0<f&&f<1&&A.push(f),g=(-b-l)/(2*a),0<g&&g<1&&A.push(g));for(var D,E,F,G=A.length,H=G;G--;)d=A[G],D=1-d,E=D*D*D*q+3*D*D*d*s+3*D*d*d*u+d*d*d*x,B[0][G]=E,F=D*D*D*r+3*D*D*d*t+3*D*d*d*w+d*d*d*y,B[1][G]=F,z[G]={X:E,Y:F};A[H]=0,A[H+1]=1,z[H]={X:q,Y:r},z[H+1]={X:x,Y:y},B[0][H]=q,B[1][H]=r,B[0][H+1]=x,B[1][H+1]=y,A.length=H+2,B[0].length=H+2,B[1].length=H+2,z.length=H+2;var I=i.apply(null,B[0]),J=i.apply(null,B[1]),K=j.apply(null,B[0]),L=j.apply(null,B[1]);return new v(I,J,K-I,L-J)},clone:function(){return new q(this.start,this.controlPoint1,this.controlPoint2,this.end)},closestPoint:function(a,b){return this.pointAtT(this.closestPointT(a,b))},closestPointLength:function(a,b){b=b||{};var c=void 0===b.precision?this.PRECISION:b.precision,d=void 0===b.subdivisions?this.getSubdivisions({precision:c}):b.subdivisions,e={precision:c,subdivisions:d};return this.lengthAtT(this.closestPointT(a,e),e)},closestPointNormalizedLength:function(a,b){b=b||{};var c=void 0===b.precision?this.PRECISION:b.precision,d=void 0===b.subdivisions?this.getSubdivisions({precision:c}):b.subdivisions,e={precision:c,subdivisions:d},f=this.closestPointLength(a,e);if(!f)return 0;var g=this.length(e);return 0===g?0:f/g},closestPointT:function(a,b){b=b||{};for(var c,d,f,g,h,i,j=void 0===b.precision?this.PRECISION:b.precision,k=void 0===b.subdivisions?this.getSubdivisions({precision:j}):b.subdivisions,l=k.length,m=l?1/l:0,n=0;n<l;n++){var o=k[n],q=o.start.distance(a),r=o.end.distance(a),s=q+r;(!i||s<i)&&(c=o,d=n*m,f=(n+1)*m,g=q,h=r,i=s)}for(var t=p(10,-j);;){var u,v;if(u=g?e(g-h)/g:0,v=h?e(g-h)/h:0,u<t||v<t)return g<=h?d:f;var w=c.divide(.5);m/=2;var x=w[0].start.distance(a),y=w[0].end.distance(a),z=x+y,A=w[1].start.distance(a),B=w[1].end.distance(a),C=A+B;z<=C?(c=w[0],f-=m,g=x,h=y):(c=w[1],d+=m,g=A,h=B)}},closestPointTangent:function(a,b){return this.tangentAtT(this.closestPointT(a,b))},divide:function(a){var b=this.start,c=this.controlPoint1,d=this.controlPoint2,e=this.end;if(a<=0)return[new q(b,b,b,b),new q(b,c,d,e)];if(a>=1)return[new q(b,c,d,e),new q(e,e,e,e)];var f=this.getSkeletonPoints(a),g=f.startControlPoint1,h=f.startControlPoint2,i=f.divider,j=f.dividerControlPoint1,k=f.dividerControlPoint2;return[new q(b,g,h,i),new q(i,j,k,e)]},endpointDistance:function(){return this.start.distance(this.end)},equals:function(a){return!!a&&this.start.x===a.start.x&&this.start.y===a.start.y&&this.controlPoint1.x===a.controlPoint1.x&&this.controlPoint1.y===a.controlPoint1.y&&this.controlPoint2.x===a.controlPoint2.x&&this.controlPoint2.y===a.controlPoint2.y&&this.end.x===a.end.x&&this.end.y===a.end.y},getSkeletonPoints:function(a){var b=this.start,c=this.controlPoint1,d=this.controlPoint2,e=this.end;if(a<=0)return{startControlPoint1:b.clone(),startControlPoint2:b.clone(),divider:b.clone(),dividerControlPoint1:c.clone(),dividerControlPoint2:d.clone()};if(a>=1)return{startControlPoint1:c.clone(),startControlPoint2:d.clone(),divider:e.clone(),dividerControlPoint1:e.clone(),dividerControlPoint2:e.clone()};var f=new s(b,c).pointAt(a),g=new s(c,d).pointAt(a),h=new s(d,e).pointAt(a),i=new s(f,g).pointAt(a),j=new s(g,h).pointAt(a),k=new s(i,j).pointAt(a),l={startControlPoint1:f,startControlPoint2:i,divider:k,dividerControlPoint1:j,dividerControlPoint2:h};return l},getSubdivisions:function(a){a=a||{};var b=void 0===a.precision?this.PRECISION:a.precision,c=[new q(this.start,this.controlPoint1,this.controlPoint2,this.end)];if(0===b)return c;for(var d=this.endpointDistance(),e=p(10,-b),f=0;;){f+=1;for(var g=[],h=c.length,i=0;i<h;i++){var j=c[i],k=j.divide(.5);g.push(k[0],k[1])}for(var l=0,m=g.length,n=0;n<m;n++){var o=g[n];l+=o.endpointDistance()}var r=0!==l?(l-d)/l:0;if(f>1&&r<e)return g;c=g,d=l}},isDifferentiable:function(){var a=this.start,b=this.controlPoint1,c=this.controlPoint2,d=this.end;return!(a.equals(b)&&b.equals(c)&&c.equals(d))},length:function(a){a=a||{};for(var b=void 0===a.precision?this.PRECISION:a.precision,c=void 0===a.subdivisions?this.getSubdivisions({precision:b}):a.subdivisions,d=0,e=c.length,f=0;f<e;f++){var g=c[f];d+=g.endpointDistance()}return d},lengthAtT:function(a,b){if(a<=0)return 0;b=b||{};var c=void 0===b.precision?this.PRECISION:b.precision,d=this.divide(a)[0],e=d.length({precision:c});return e},pointAt:function(a,b){if(a<=0)return this.start.clone();if(a>=1)return this.end.clone();var c=this.tAt(a,b);return this.pointAtT(c)},pointAtLength:function(a,b){var c=this.tAtLength(a,b);return this.pointAtT(c)},pointAtT:function(a){return a<=0?this.start.clone():a>=1?this.end.clone():this.getSkeletonPoints(a).divider},PRECISION:3,scale:function(a,b,c){return this.start.scale(a,b,c),this.controlPoint1.scale(a,b,c),this.controlPoint2.scale(a,b,c),this.end.scale(a,b,c),this},tangentAt:function(a,b){if(!this.isDifferentiable())return null;a<0?a=0:a>1&&(a=1);var c=this.tAt(a,b);return this.tangentAtT(c)},tangentAtLength:function(a,b){if(!this.isDifferentiable())return null;var c=this.tAtLength(a,b);return this.tangentAtT(c)},tangentAtT:function(a){if(!this.isDifferentiable())return null;a<0?a=0:a>1&&(a=1);var b=this.getSkeletonPoints(a),c=b.startControlPoint2,d=b.dividerControlPoint1,e=b.divider,f=new s(c,d);return f.translate(e.x-c.x,e.y-c.y),f},tAt:function(a,b){if(a<=0)return 0;if(a>=1)return 1;b=b||{};var c=void 0===b.precision?this.PRECISION:b.precision,d=void 0===b.subdivisions?this.getSubdivisions({precision:c}):b.subdivisions,e={precision:c,subdivisions:d},f=this.length(e),g=f*a;return this.tAtLength(g,e)},tAtLength:function(a,b){var c=!0;a<0&&(c=!1,a=-a),b=b||{};for(var d,e,f,g,h,i=void 0===b.precision?this.PRECISION:b.precision,j=void 0===b.subdivisions?this.getSubdivisions({precision:i}):b.subdivisions,k={precision:i,subdivisions:j},l=0,m=j.length,n=1/m,o=c?0:m-1;c?o<m:o>=0;c?o++:o--){var q=j[o],r=q.endpointDistance();if(a<=l+r){d=q,e=o*n,f=(o+1)*n,g=c?a-l:r+l-a,h=c?r+l-a:a-l;break}l+=r}if(!d)return c?1:0;for(var s=this.length(k),t=p(10,-i);;){var u;if(u=0!==s?g/s:0,u<t)return e;if(u=0!==s?h/s:0,u<t)return f;var v,w,x=d.divide(.5);n/=2;var y=x[0].endpointDistance(),z=x[1].endpointDistance();g<=y?(d=x[0],f-=n,v=g,w=y-v):(d=x[1],e+=n,v=g-y,w=z-v),g=v,h=w}},translate:function(a,b){return this.start.translate(a,b),this.controlPoint1.translate(a,b),this.controlPoint2.translate(a,b),this.end.translate(a,b),this},toPoints:function(a){a=a||{};for(var b=void 0===a.precision?this.PRECISION:a.precision,c=void 0===a.subdivisions?this.getSubdivisions({precision:b}):a.subdivisions,d=[c[0].start.clone()],e=c.length,f=0;f<e;f++){var g=c[f];d.push(g.end.clone())}return d},toPolyline:function(a){return new w(this.toPoints(a))},toString:function(){return this.start+" "+this.controlPoint1+" "+this.controlPoint2+" "+this.end}};var r=c.Ellipse=function(a,b,c){return this instanceof r?a instanceof r?new r(new u(a.x,a.y),a.a,a.b):(a=new u(a),this.x=a.x,this.y=a.y,this.a=b,void(this.b=c)):new r(a,b,c)};r.fromRect=function(a){return a=new v(a),new r(a.center(),a.width/2,a.height/2)},r.prototype={bbox:function(){return new v(this.x-this.a,this.y-this.b,2*this.a,2*this.b)},clone:function(){return new r(this)},normalizedDistance:function(a){var b=a.x,c=a.y,d=this.a,e=this.b,f=this.x,g=this.y;return(b-f)*(b-f)/(d*d)+(c-g)*(c-g)/(e*e)},inflate:function(a,b){return void 0===a&&(a=0),void 0===b&&(b=a),this.a+=2*a,this.b+=2*b,this},containsPoint:function(a){return this.normalizedDistance(a)<=1},center:function(){return new u(this.x,this.y)},tangentTheta:function(a){var b,c,d=30,e=a.x,f=a.y,g=this.a,h=this.b,i=this.bbox().center(),j=i.x,k=i.y,l=e>i.x+g/2,m=e<i.x-g/2;return l||m?(b=e>i.x?f-d:f+d,c=g*g/(e-j)-g*g*(f-k)*(b-k)/(h*h*(e-j))+j):(c=f>i.y?e+d:e-d,b=h*h/(f-k)-h*h*(e-j)*(c-j)/(g*g*(f-k))+k),new u(c,b).theta(a)},equals:function(a){return!!a&&a.x===this.x&&a.y===this.y&&a.a===this.a&&a.b===this.b},intersectionWithLine:function(a){var b=[],c=a.start,d=a.end,e=this.a,f=this.b,g=a.vector(),i=c.difference(new u(this)),j=new u(g.x/(e*e),g.y/(f*f)),k=new u(i.x/(e*e),i.y/(f*f)),l=g.dot(j),m=g.dot(k),n=i.dot(k)-1,o=m*m-l*n;if(o<0)return null;if(o>0){var p=h(o),q=(-m-p)/l,r=(-m+p)/l;if((q<0||1<q)&&(r<0||1<r))return null;0<=q&&q<=1&&b.push(c.lerp(d,q)),0<=r&&r<=1&&b.push(c.lerp(d,r))}else{var s=-m/l;if(!(0<=s&&s<=1))return null;b.push(c.lerp(d,s))}return b},intersectionWithLineFromCenterToPoint:function(a,b){a=new u(a),b&&a.rotate(new u(this.x,this.y),b);var c,d=a.x-this.x,e=a.y-this.y;if(0===d)return c=this.bbox().pointNearestToPoint(a),b?c.rotate(new u(this.x,this.y),-b):c;var f=e/d,g=f*f,i=this.a*this.a,j=this.b*this.b,k=h(1/(1/i+g/j));k=d<0?-k:k;var l=f*k;return c=new u(this.x+k,this.y+l),b?c.rotate(new u(this.x,this.y),-b):c},toString:function(){return new u(this.x,this.y).toString()+" "+this.a+" "+this.b}};var s=c.Line=function(a,b){return this instanceof s?a instanceof s?new s(a.start,a.end):(this.start=new u(a),void(this.end=new u(b))):new s(a,b)};s.prototype={bbox:function(){var a=i(this.start.x,this.end.x),b=i(this.start.y,this.end.y),c=j(this.start.x,this.end.x),d=j(this.start.y,this.end.y);return new v(a,b,c-a,d-b)},bearing:function(){var a=A(this.start.y),b=A(this.end.y),c=this.start.x,d=this.end.x,e=A(d-c),h=g(e)*f(b),i=f(a)*g(b)-g(a)*f(b)*f(e),j=z(k(h,i)),l=["NE","E","SE","S","SW","W","NW","N"],m=j-22.5;return m<0&&(m+=360),m=parseInt(m/45),l[m]},clone:function(){return new s(this.start,this.end)},closestPoint:function(a){return this.pointAt(this.closestPointNormalizedLength(a))},closestPointLength:function(a){return this.closestPointNormalizedLength(a)*this.length()},closestPointNormalizedLength:function(a){var b=this.vector().dot(new s(this.start,a).vector()),c=i(1,j(0,b/this.squaredLength()));return c!==c?0:c},closestPointTangent:function(a){return this.tangentAt(this.closestPointNormalizedLength(a))},equals:function(a){return!!a&&this.start.x===a.start.x&&this.start.y===a.start.y&&this.end.x===a.end.x&&this.end.y===a.end.y},intersectionWithLine:function(a){var b=new u(this.end.x-this.start.x,this.end.y-this.start.y),c=new u(a.end.x-a.start.x,a.end.y-a.start.y),d=b.x*c.y-b.y*c.x,e=new u(a.start.x-this.start.x,a.start.y-this.start.y),f=e.x*c.y-e.y*c.x,g=e.x*b.y-e.y*b.x;if(0===d||f*d<0||g*d<0)return null;if(d>0){if(f>d||g>d)return null}else if(f<d||g<d)return null;return[new u(this.start.x+f*b.x/d,this.start.y+f*b.y/d)]},intersect:function(a,b){if(a instanceof s||a instanceof v||a instanceof w||a instanceof r||a instanceof t){var c=a.intersectionWithLine(this,b);return c&&a instanceof s&&(c=c[0]),c}return null},isDifferentiable:function(){return!this.start.equals(this.end)},length:function(){return h(this.squaredLength())},midpoint:function(){return new u((this.start.x+this.end.x)/2,(this.start.y+this.end.y)/2)},pointAt:function(a){var b=this.start,c=this.end;return a<=0?b.clone():a>=1?c.clone():b.lerp(c,a)},pointAtLength:function(a){var b=this.start,c=this.end,d=!0;a<0&&(d=!1,a=-a);var e=this.length();return a>=e?d?c.clone():b.clone():this.pointAt((d?a:e-a)/e)},pointOffset:function(a){a=new c.Point(a);var b=this.start,d=this.end,e=(d.x-b.x)*(a.y-b.y)-(d.y-b.y)*(a.x-b.x);return e/this.length()},rotate:function(a,b){return this.start.rotate(a,b),this.end.rotate(a,b),this},round:function(a){var b=p(10,a||0);return this.start.x=l(this.start.x*b)/b,this.start.y=l(this.start.y*b)/b,this.end.x=l(this.end.x*b)/b,this.end.y=l(this.end.y*b)/b,this},scale:function(a,b,c){return this.start.scale(a,b,c),this.end.scale(a,b,c),this},setLength:function(a){var b=this.length();if(!b)return this;var c=a/b;return this.scale(c,c,this.start)},squaredLength:function(){var a=this.start.x,b=this.start.y,c=this.end.x,d=this.end.y;return(a-=c)*a+(b-=d)*b},tangentAt:function(a){if(!this.isDifferentiable())return null;var b=this.start,c=this.end,d=this.pointAt(a),e=new s(b,c);return e.translate(d.x-b.x,d.y-b.y),e},tangentAtLength:function(a){if(!this.isDifferentiable())return null;var b=this.start,c=this.end,d=this.pointAtLength(a),e=new s(b,c);return e.translate(d.x-b.x,d.y-b.y),e},translate:function(a,b){return this.start.translate(a,b),this.end.translate(a,b),this},vector:function(){return new u(this.end.x-this.start.x,this.end.y-this.start.y)},toString:function(){return this.start.toString()+" "+this.end.toString()}},s.prototype.intersection=s.prototype.intersect;var t=c.Path=function(a){if(!(this instanceof t))return new t(a);if("string"==typeof a)return new t.parse(a);this.segments=[];var b,c;if(a){if(Array.isArray(a)&&0!==a.length)if(c=a.length,a[0].isSegment)for(b=0;b<c;b++){var d=a[b];this.appendSegment(d)}else{var e=null;for(b=0;b<c;b++){var f=a[b];if(!(f instanceof s||f instanceof q))throw new Error("Cannot construct a path segment from the provided object.");0===b&&this.appendSegment(t.createSegment("M",f.start)),e&&!e.end.equals(f.start)&&this.appendSegment(t.createSegment("M",f.start)),f instanceof s?this.appendSegment(t.createSegment("L",f.end)):f instanceof q&&this.appendSegment(t.createSegment("C",f.controlPoint1,f.controlPoint2,f.end)),e=f}}else if(a.isSegment)this.appendSegment(a);else if(a instanceof s)this.appendSegment(t.createSegment("M",a.start)),this.appendSegment(t.createSegment("L",a.end));else if(a instanceof q)this.appendSegment(t.createSegment("M",a.start)),this.appendSegment(t.createSegment("C",a.controlPoint1,a.controlPoint2,a.end));else if(a instanceof w&&a.points&&0!==a.points.length)for(c=a.points.length,b=0;b<c;b++){var g=a.points[b];0===b?this.appendSegment(t.createSegment("M",g)):this.appendSegment(t.createSegment("L",g))}}else;};t.parse=function(a){if(!a)return new t;for(var b=new t,c=/(?:[a-zA-Z] *)(?:(?:-?\d+(?:\.\d+)? *,? *)|(?:-?\.\d+ *,? *))+|(?:[a-zA-Z] *)(?! |\d|-|\.)/g,d=a.match(c),e=d.length,f=0;f<e;f++){var g=d[f],h=/(?:[a-zA-Z])|(?:(?:-?\d+(?:\.\d+)?))|(?:(?:-?\.\d+))/g,i=g.match(h),j=t.createSegment.apply(this,i);b.appendSegment(j)}return b},t.createSegment=function(b){if(!b)throw new Error("Type must be provided.");var c=t.segmentTypes[b];if(!c)throw new Error(b+" is not a recognized path segment type.");for(var d=[],e=arguments.length,f=1;f<e;f++)d.push(arguments[f]);return a(c,d)},t.prototype={appendSegment:function(a){var b,c=this.segments,d=c.length,e=0!==d?c[d-1]:null,f=null;if(Array.isArray(a)){if(!a[0].isSegment)throw new Error("Segments required.");for(var g=a.length,h=0;h<g;h++){var i=a[h];b=this.prepareSegment(i,e,f),c.push(b),e=b}}else{if(!a||!a.isSegment)throw new Error("Segment required.");b=this.prepareSegment(a,e,f),c.push(b)}},bbox:function(){var a=this.segments,b=a.length;if(0===b)return null;for(var c,d=0;d<b;d++){var e=a[d];if(e.isVisible){var f=e.bbox();c=c?c.union(f):f}}if(c)return c;var g=a[b-1];return new v(g.end.x,g.end.y,0,0)},clone:function(){for(var a=this.segments,b=a.length,c=new t,d=0;d<b;d++){var e=a[d].clone();c.appendSegment(e)}return c},closestPoint:function(a,b){var c=this.closestPointT(a,b);return c?this.pointAtT(c):null},closestPointLength:function(a,b){b=b||{};var c=void 0===b.precision?this.PRECISION:b.precision,d=void 0===b.segmentSubdivisions?this.getSegmentSubdivisions({precision:c}):b.segmentSubdivisions,e={precision:c,segmentSubdivisions:d},f=this.closestPointT(a,e);return f?this.lengthAtT(f,e):0},closestPointNormalizedLength:function(a,b){b=b||{};var c=void 0===b.precision?this.PRECISION:b.precision,d=void 0===b.segmentSubdivisions?this.getSegmentSubdivisions({precision:c}):b.segmentSubdivisions,e={precision:c,segmentSubdivisions:d},f=this.closestPointLength(a,e);if(0===f)return 0;var g=this.length(e);return 0===g?0:f/g},closestPointT:function(a,b){var c=this.segments,d=c.length;if(0===d)return null;b=b||{};for(var e,f=void 0===b.precision?this.PRECISION:b.precision,g=void 0===b.segmentSubdivisions?this.getSegmentSubdivisions({precision:f}):b.segmentSubdivisions,h=1/0,i=0;i<d;i++){var j=c[i],k=g[i];if(j.isVisible){var l=j.closestPointT(a,{precision:f,subdivisions:k}),m=j.pointAtT(l),n=new s(m,a).squaredLength();n<h&&(e={segmentIndex:i,value:l},h=n)}}return e?e:{segmentIndex:d-1,value:1}},closestPointTangent:function(a,b){var c=this.segments,d=c.length;if(0===d)return null;b=b||{};for(var e,f=void 0===b.precision?this.PRECISION:b.precision,g=void 0===b.segmentSubdivisions?this.getSegmentSubdivisions({precision:f}):b.segmentSubdivisions,h=1/0,i=0;i<d;i++){var j=c[i],k=g[i];if(j.isDifferentiable()){var l=j.closestPointT(a,{precision:f,subdivisions:k}),m=j.pointAtT(l),n=new s(m,a).squaredLength();n<h&&(e=j.tangentAtT(l),h=n)}}return e?e:null},equals:function(a){if(!a)return!1;var b=this.segments,c=a.segments,d=b.length;if(c.length!==d)return!1;for(var e=0;e<d;e++){var f=b[e],g=c[e];if(f.type!==g.type||!f.equals(g))return!1}return!0},getSegment:function(a){var b=this.segments,c=b.length;if(0===!c)throw new Error("Path has no segments.");if(a<0&&(a=c+a),a>=c||a<0)throw new Error("Index out of range.");return b[a]},getSegmentSubdivisions:function(a){var b=this.segments,c=b.length;a=a||{};for(var d=void 0===a.precision?this.PRECISION:a.precision,e=[],f=0;f<c;f++){var g=b[f],h=g.getSubdivisions({precision:d});e.push(h)}return e},insertSegment:function(a,b){var c=this.segments,d=c.length;if(a<0&&(a=d+a+1),a>d||a<0)throw new Error("Index out of range.");var e,f=null,g=null;if(0!==d&&(a>=1?(f=c[a-1],g=f.nextSegment):g=c[0]),Array.isArray(b)){if(!b[0].isSegment)throw new Error("Segments required.");for(var h=b.length,i=0;i<h;i++){var j=b[i];e=this.prepareSegment(j,f,g),c.splice(a+i,0,e),f=e}}else{if(!b||!b.isSegment)throw new Error("Segment required.");e=this.prepareSegment(b,f,g),c.splice(a,0,e)}},isDifferentiable:function(){for(var a=this.segments,b=a.length,c=0;c<b;c++){var d=a[c];if(d.isDifferentiable())return!0}return!1},isValid:function(){var a=this.segments,b=0===a.length||"M"===a[0].type;return b},length:function(a){var b=this.segments,c=b.length;if(0===c)return 0;a=a||{};for(var d=void 0===a.precision?this.PRECISION:a.precision,e=void 0===a.segmentSubdivisions?this.getSegmentSubdivisions({precision:d}):a.segmentSubdivisions,f=0,g=0;g<c;g++){var h=b[g],i=e[g];f+=h.length({subdivisions:i})}return f},lengthAtT:function(a,b){var c=this.segments,d=c.length;if(0===d)return 0;var e=a.segmentIndex;if(e<0)return 0;var f=a.value;e>=d?(e=d-1,f=1):f<0?f=0:f>1&&(f=1),b=b||{};for(var g,h=void 0===b.precision?this.PRECISION:b.precision,i=void 0===b.segmentSubdivisions?this.getSegmentSubdivisions({precision:h}):b.segmentSubdivisions,j=0,k=0;k<e;k++){var l=c[k];g=i[k],j+=l.length({precisison:h,subdivisions:g})}return l=c[e],g=i[e],j+=l.lengthAtT(f,{precisison:h,subdivisions:g})},pointAt:function(a,b){var c=this.segments,d=c.length;if(0===d)return null;if(a<=0)return this.start.clone();if(a>=1)return this.end.clone();b=b||{};var e=void 0===b.precision?this.PRECISION:b.precision,f=void 0===b.segmentSubdivisions?this.getSegmentSubdivisions({precision:e}):b.segmentSubdivisions,g={precision:e,segmentSubdivisions:f},h=this.length(g),i=h*a;return this.pointAtLength(i,g)},pointAtLength:function(a,b){var c=this.segments,d=c.length;if(0===d)return null;if(0===a)return this.start.clone();var e=!0;a<0&&(e=!1,a=-a),b=b||{};for(var f,g=void 0===b.precision?this.PRECISION:b.precision,h=void 0===b.segmentSubdivisions?this.getSegmentSubdivisions({precision:g}):b.segmentSubdivisions,i=0,j=e?0:d-1;e?j<d:j>=0;e?j++:j--){var k=c[j],l=h[j],m=k.length({precision:g,subdivisions:l});if(k.isVisible){if(a<=i+m)return k.pointAtLength((e?1:-1)*(a-i),{precision:g,subdivisions:l});f=k}i+=m}if(f)return e?f.end:f.start;var n=c[d-1];return n.end.clone()},pointAtT:function(a){var b=this.segments,c=b.length;if(0===c)return null;var d=a.segmentIndex;if(d<0)return b[0].pointAtT(0);if(d>=c)return b[c-1].pointAtT(1);var e=a.value;return e<0?e=0:e>1&&(e=1),b[d].pointAtT(e)},prepareSegment:function(a,b,c){a.previousSegment=b,a.nextSegment=c,b&&(b.nextSegment=a),c&&(c.previousSegment=a);var d=a;return a.isSubpathStart&&(a.subpathStartSegment=a,d=c),d&&this.updateSubpathStartSegment(d),a},PRECISION:3,removeSegment:function(a){var b=this.segments,c=b.length;if(0===c)throw new Error("Path has no segments.");if(a<0&&(a=c+a),a>=c||a<0)throw new Error("Index out of range.");var d=b.splice(a,1)[0],e=d.previousSegment,f=d.nextSegment;e&&(e.nextSegment=f),f&&(f.previousSegment=e),d.isSubpathStart&&f&&this.updateSubpathStartSegment(f)},replaceSegment:function(a,b){var c=this.segments,d=c.length;if(0===d)throw new Error("Path has no segments.");if(a<0&&(a=d+a),a>=d||a<0)throw new Error("Index out of range.");var e,f=c[a],g=f.previousSegment,h=f.nextSegment,i=f.isSubpathStart;if(Array.isArray(b)){if(!b[0].isSegment)throw new Error("Segments required.");c.splice(a,1);for(var j=b.length,k=0;k<j;k++){var l=b[k];e=this.prepareSegment(l,g,h),c.splice(a+k,0,e),g=e,i&&e.isSubpathStart&&(i=!1)}}else{if(!b||!b.isSegment)throw new Error("Segment required.");e=this.prepareSegment(b,g,h),c.splice(a,1,e),i&&e.isSubpathStart&&(i=!1)}i&&h&&this.updateSubpathStartSegment(h)},scale:function(a,b,c){for(var d=this.segments,e=d.length,f=0;f<e;f++){var g=d[f];g.scale(a,b,c)}return this},segmentAt:function(a,b){var c=this.segmentIndexAt(a,b);return c?this.getSegment(c):null},segmentAtLength:function(a,b){var c=this.segmentIndexAtLength(a,b);return c?this.getSegment(c):null},segmentIndexAt:function(a,b){var c=this.segments,d=c.length;if(0===d)return null;a<0&&(a=0),a>1&&(a=1),b=b||{};var e=void 0===b.precision?this.PRECISION:b.precision,f=void 0===b.segmentSubdivisions?this.getSegmentSubdivisions({precision:e}):b.segmentSubdivisions,g={precision:e,segmentSubdivisions:f},h=this.length(g),i=h*a;return this.segmentIndexAtLength(i,g)},toPoints:function(a){var b=this.segments,c=b.length;if(0===c)return null;a=a||{};for(var d=void 0===a.precision?this.PRECISION:a.precision,e=void 0===a.segmentSubdivisions?this.getSegmentSubdivisions({precision:d}):a.segmentSubdivisions,f=[],g=[],h=0;h<c;h++){var i=b[h];if(i.isVisible){var j=e[h];if(j.length>0){var k=j.map(function(a){return a.start});Array.prototype.push.apply(g,k)}else g.push(i.start)}else g.length>0&&(g.push(b[h-1].end),f.push(g),g=[])}return g.length>0&&(g.push(this.end),f.push(g)),f},toPolylines:function(a){var b=[],c=this.toPoints(a);if(!c)return null;for(var d=0,e=c.length;d<e;d++)b.push(new w(c[d]));return b},intersectionWithLine:function(a,b){var c=null,d=this.toPolylines(b);if(!d)return null;for(var e=0,f=d.length;e<f;e++){var g=d[e],h=a.intersect(g);h&&(c||(c=[]),Array.isArray(h)?Array.prototype.push.apply(c,h):c.push(h))}return c},segmentIndexAtLength:function(a,b){var c=this.segments,d=c.length;if(0===d)return null;var e=!0;a<0&&(e=!1,a=-a),b=b||{};for(var f=void 0===b.precision?this.PRECISION:b.precision,g=void 0===b.segmentSubdivisions?this.getSegmentSubdivisions({precision:f}):b.segmentSubdivisions,h=null,i=0,j=e?0:d-1;e?j<d:j>=0;e?j++:j--){var k=c[j],l=g[j],m=k.length({precision:f,subdivisions:l});if(k.isVisible){if(a<=i+m)return j;h=j}i+=m}return h},tangentAt:function(a,b){var c=this.segments,d=c.length;if(0===d)return null;a<0&&(a=0),a>1&&(a=1),b=b||{};var e=void 0===b.precision?this.PRECISION:b.precision,f=void 0===b.segmentSubdivisions?this.getSegmentSubdivisions({precision:e}):b.segmentSubdivisions,g={precision:e,segmentSubdivisions:f},h=this.length(g),i=h*a;return this.tangentAtLength(i,g)},tangentAtLength:function(a,b){var c=this.segments,d=c.length;if(0===d)return null;var e=!0;a<0&&(e=!1,a=-a),b=b||{};for(var f,g=void 0===b.precision?this.PRECISION:b.precision,h=void 0===b.segmentSubdivisions?this.getSegmentSubdivisions({precision:g}):b.segmentSubdivisions,i=0,j=e?0:d-1;e?j<d:j>=0;e?j++:j--){var k=c[j],l=h[j],m=k.length({precision:g,subdivisions:l});if(k.isDifferentiable()){if(a<=i+m)return k.tangentAtLength((e?1:-1)*(a-i),{precision:g,subdivisions:l});f=k}i+=m}if(f){var n=e?1:0;return f.tangentAtT(n)}return null},tangentAtT:function(a){var b=this.segments,c=b.length;if(0===c)return null;var d=a.segmentIndex;if(d<0)return b[0].tangentAtT(0);if(d>=c)return b[c-1].tangentAtT(1);var e=a.value;return e<0?e=0:e>1&&(e=1),b[d].tangentAtT(e)},translate:function(a,b){for(var c=this.segments,d=c.length,e=0;e<d;e++){var f=c[e];f.translate(a,b)}return this},updateSubpathStartSegment:function(a){for(var b=a.previousSegment;a&&!a.isSubpathStart;)b?a.subpathStartSegment=b.subpathStartSegment:a.subpathStartSegment=null,b=a,a=a.nextSegment},serialize:function(){if(!this.isValid())throw new Error("Invalid path segments.");return this.toString()},toString:function(){for(var a=this.segments,b=a.length,c="",d=0;d<b;d++){var e=a[d];c+=e.serialize()+" "}return c.trim()}},Object.defineProperty(t.prototype,"start",{configurable:!0,enumerable:!0,get:function(){var a=this.segments,b=a.length;if(0===b)return null;for(var c=0;c<b;c++){var d=a[c];if(d.isVisible)return d.start}return a[b-1].end}}),Object.defineProperty(t.prototype,"end",{configurable:!0,enumerable:!0,get:function(){var a=this.segments,b=a.length;if(0===b)return null;for(var c=b-1;c>=0;c--){var d=a[c];if(d.isVisible)return d.end}return a[b-1].end}});var u=c.Point=function(a,b){if(!(this instanceof u))return new u(a,b);if("string"==typeof a){var c=a.split(a.indexOf("@")===-1?" ":"@");a=parseFloat(c[0]),b=parseFloat(c[1])}else Object(a)===a&&(b=a.y,a=a.x);this.x=void 0===a?0:a,this.y=void 0===b?0:b};u.fromPolar=function(a,b,c){c=c&&new u(c)||new u(0,0);var d=e(a*f(b)),h=e(a*g(b)),i=x(z(b));return i<90?h=-h:i<180?(d=-d,h=-h):i<270&&(d=-d),new u(c.x+d,c.y+h)},u.random=function(a,b,c,d){return new u(m(o()*(b-a+1)+a),m(o()*(d-c+1)+c))},u.prototype={adhereToRect:function(a){return a.containsPoint(this)?this:(this.x=i(j(this.x,a.x),a.x+a.width),this.y=i(j(this.y,a.y),a.y+a.height),this)},bearing:function(a){return new s(this,a).bearing()},changeInAngle:function(a,b,c){return this.clone().offset(-a,-b).theta(c)-this.theta(c)},clone:function(){return new u(this)},difference:function(a,b){return Object(a)===a&&(b=a.y,a=a.x),new u(this.x-(a||0),this.y-(b||0))},distance:function(a){return new s(this,a).length()},squaredDistance:function(a){return new s(this,a).squaredLength()},equals:function(a){return!!a&&this.x===a.x&&this.y===a.y},magnitude:function(){return h(this.x*this.x+this.y*this.y)||.01},manhattanDistance:function(a){return e(a.x-this.x)+e(a.y-this.y)},move:function(a,b){var c=A(new u(a).theta(this)),d=this.offset(f(c)*b,-g(c)*b);return d},normalize:function(a){var b=(a||1)/this.magnitude();return this.scale(b,b)},offset:function(a,b){return Object(a)===a&&(b=a.y,a=a.x),this.x+=a||0,this.y+=b||0,this},reflection:function(a){return new u(a).move(this,this.distance(a))},rotate:function(a,b){a=a||new c.Point(0,0),b=A(x(-b));var d=f(b),e=g(b),h=d*(this.x-a.x)-e*(this.y-a.y)+a.x,i=e*(this.x-a.x)+d*(this.y-a.y)+a.y;return this.x=h,this.y=i,this},round:function(a){var b=p(10,a||0);return this.x=l(this.x*b)/b,this.y=l(this.y*b)/b,this},scale:function(a,b,c){return c=c&&new u(c)||new u(0,0),this.x=c.x+a*(this.x-c.x),this.y=c.y+b*(this.y-c.y),this},snapToGrid:function(a,b){return this.x=y(this.x,a),this.y=y(this.y,b||a),this},theta:function(a){a=new u(a);var b=-(a.y-this.y),c=a.x-this.x,d=k(b,c);return d<0&&(d=2*n+d),180*d/n},angleBetween:function(a,b){var c=this.equals(a)||this.equals(b)?NaN:this.theta(b)-this.theta(a);return c<0&&(c+=360),c},vectorAngle:function(a){var b=new u(0,0);return b.angleBetween(this,a)},toJSON:function(){return{x:this.x,y:this.y}},toPolar:function(a){a=a&&new u(a)||new u(0,0);var b=this.x,c=this.y;return this.x=h((b-a.x)*(b-a.x)+(c-a.y)*(c-a.y)),this.y=A(a.theta(new u(b,c))),this},toString:function(){return this.x+"@"+this.y},update:function(a,b){return this.x=a||0,this.y=b||0,this},dot:function(a){return a?this.x*a.x+this.y*a.y:NaN},cross:function(a,b){return a&&b?(b.x-this.x)*(a.y-this.y)-(b.y-this.y)*(a.x-this.x):NaN},lerp:function(a,b){var c=this.x,d=this.y;return new u((1-b)*c+b*a.x,(1-b)*d+b*a.y)}},u.prototype.translate=u.prototype.offset;var v=c.Rect=function(a,b,c,d){return this instanceof v?(Object(a)===a&&(b=a.y,c=a.width,d=a.height,a=a.x),this.x=void 0===a?0:a,this.y=void 0===b?0:b,this.width=void 0===c?0:c,void(this.height=void 0===d?0:d)):new v(a,b,c,d)};v.fromEllipse=function(a){return a=new r(a),new v(a.x-a.a,a.y-a.b,2*a.a,2*a.b)},v.prototype={bbox:function(a){if(!a)return this.clone();var b=A(a||0),c=e(g(b)),d=e(f(b)),h=this.width*d+this.height*c,i=this.width*c+this.height*d;return new v(this.x+(this.width-h)/2,this.y+(this.height-i)/2,h,i)},bottomLeft:function(){return new u(this.x,this.y+this.height)},bottomLine:function(){return new s(this.bottomLeft(),this.bottomRight())},bottomMiddle:function(){return new u(this.x+this.width/2,this.y+this.height);
},center:function(){return new u(this.x+this.width/2,this.y+this.height/2)},clone:function(){return new v(this)},containsPoint:function(a){return a=new u(a),a.x>=this.x&&a.x<=this.x+this.width&&a.y>=this.y&&a.y<=this.y+this.height},containsRect:function(a){var b=new v(this).normalize(),c=new v(a).normalize(),d=b.width,e=b.height,f=c.width,g=c.height;if(!(d&&e&&f&&g))return!1;var h=b.x,i=b.y,j=c.x,k=c.y;return f+=j,d+=h,g+=k,e+=i,h<=j&&f<=d&&i<=k&&g<=e},corner:function(){return new u(this.x+this.width,this.y+this.height)},equals:function(a){var b=new v(this).normalize(),c=new v(a).normalize();return b.x===c.x&&b.y===c.y&&b.width===c.width&&b.height===c.height},intersect:function(a){var b=this.origin(),c=this.corner(),d=a.origin(),e=a.corner();if(e.x<=b.x||e.y<=b.y||d.x>=c.x||d.y>=c.y)return null;var f=j(b.x,d.x),g=j(b.y,d.y);return new v(f,g,i(c.x,e.x)-f,i(c.y,e.y)-g)},intersectionWithLine:function(a){var b,c,d=this,e=[d.topLine(),d.rightLine(),d.bottomLine(),d.leftLine()],f=[],g=[],h=e.length;for(c=0;c<h;c++)b=a.intersect(e[c]),null!==b&&g.indexOf(b.toString())<0&&(f.push(b),g.push(b.toString()));return f.length>0?f:null},intersectionWithLineFromCenterToPoint:function(a,b){a=new u(a);var c,d=new u(this.x+this.width/2,this.y+this.height/2);b&&a.rotate(d,b);for(var e=[this.topLine(),this.rightLine(),this.bottomLine(),this.leftLine()],f=new s(d,a),g=e.length-1;g>=0;--g){var h=e[g].intersection(f);if(null!==h){c=h;break}}return c&&b&&c.rotate(d,-b),c},leftLine:function(){return new s(this.topLeft(),this.bottomLeft())},leftMiddle:function(){return new u(this.x,this.y+this.height/2)},moveAndExpand:function(a){return this.x+=a.x||0,this.y+=a.y||0,this.width+=a.width||0,this.height+=a.height||0,this},offset:function(a,b){return u.prototype.offset.call(this,a,b)},inflate:function(a,b){return void 0===a&&(a=0),void 0===b&&(b=a),this.x-=a,this.y-=b,this.width+=2*a,this.height+=2*b,this},normalize:function(){var a=this.x,b=this.y,c=this.width,d=this.height;return this.width<0&&(a=this.x+this.width,c=-this.width),this.height<0&&(b=this.y+this.height,d=-this.height),this.x=a,this.y=b,this.width=c,this.height=d,this},origin:function(){return new u(this.x,this.y)},pointNearestToPoint:function(a){if(a=new u(a),this.containsPoint(a)){var b=this.sideNearestToPoint(a);switch(b){case"right":return new u(this.x+this.width,a.y);case"left":return new u(this.x,a.y);case"bottom":return new u(a.x,this.y+this.height);case"top":return new u(a.x,this.y)}}return a.adhereToRect(this)},rightLine:function(){return new s(this.topRight(),this.bottomRight())},rightMiddle:function(){return new u(this.x+this.width,this.y+this.height/2)},round:function(a){var b=p(10,a||0);return this.x=l(this.x*b)/b,this.y=l(this.y*b)/b,this.width=l(this.width*b)/b,this.height=l(this.height*b)/b,this},scale:function(a,b,c){return c=this.origin().scale(a,b,c),this.x=c.x,this.y=c.y,this.width*=a,this.height*=b,this},maxRectScaleToFit:function(a,b){a=new v(a),b||(b=a.center());var c,d,e,f,g,h,j,k,l=b.x,m=b.y;c=d=e=f=g=h=j=k=1/0;var n=a.topLeft();n.x<l&&(c=(this.x-l)/(n.x-l)),n.y<m&&(g=(this.y-m)/(n.y-m));var o=a.bottomRight();o.x>l&&(d=(this.x+this.width-l)/(o.x-l)),o.y>m&&(h=(this.y+this.height-m)/(o.y-m));var p=a.topRight();p.x>l&&(e=(this.x+this.width-l)/(p.x-l)),p.y<m&&(j=(this.y-m)/(p.y-m));var q=a.bottomLeft();return q.x<l&&(f=(this.x-l)/(q.x-l)),q.y>m&&(k=(this.y+this.height-m)/(q.y-m)),{sx:i(c,d,e,f),sy:i(g,h,j,k)}},maxRectUniformScaleToFit:function(a,b){var c=this.maxRectScaleToFit(a,b);return i(c.sx,c.sy)},sideNearestToPoint:function(a){a=new u(a);var b=a.x-this.x,c=this.x+this.width-a.x,d=a.y-this.y,e=this.y+this.height-a.y,f=b,g="left";return c<f&&(f=c,g="right"),d<f&&(f=d,g="top"),e<f&&(f=e,g="bottom"),g},snapToGrid:function(a,b){var c=this.origin().snapToGrid(a,b),d=this.corner().snapToGrid(a,b);return this.x=c.x,this.y=c.y,this.width=d.x-c.x,this.height=d.y-c.y,this},topLine:function(){return new s(this.topLeft(),this.topRight())},topMiddle:function(){return new u(this.x+this.width/2,this.y)},topRight:function(){return new u(this.x+this.width,this.y)},toJSON:function(){return{x:this.x,y:this.y,width:this.width,height:this.height}},toString:function(){return this.origin().toString()+" "+this.corner().toString()},union:function(a){a=new v(a);var b=this.origin(),c=this.corner(),d=a.origin(),e=a.corner(),f=i(b.x,d.x),g=i(b.y,d.y),h=j(c.x,e.x),k=j(c.y,e.y);return new v(f,g,h-f,k-g)}},v.prototype.bottomRight=v.prototype.corner,v.prototype.topLeft=v.prototype.origin,v.prototype.translate=v.prototype.offset;var w=c.Polyline=function(a){return this instanceof w?"string"==typeof a?new w.parse(a):void(this.points=Array.isArray(a)?a.map(u):[]):new w(a)};w.parse=function(a){if(""===a)return new w;for(var b=[],c=a.split(/\s|,/),d=c.length,e=0;e<d;e+=2)b.push({x:+c[e],y:+c[e+1]});return new w(b)},w.prototype={bbox:function(){var a=1/0,b=-(1/0),c=1/0,d=-(1/0),e=this.points,f=e.length;if(0===f)return null;for(var g=0;g<f;g++){var h=e[g],i=h.x,j=h.y;i<a&&(a=i),i>b&&(b=i),j<c&&(c=j),j>d&&(d=j)}return new v(a,c,b-a,d-c)},clone:function(){var a=this.points,b=a.length;if(0===b)return new w;for(var c=[],d=0;d<b;d++){var e=a[d].clone();c.push(e)}return new w(c)},closestPoint:function(a){var b=this.closestPointLength(a);return this.pointAtLength(b)},closestPointLength:function(a){var b=this.points,c=b.length;if(0===c)return 0;if(1===c)return 0;for(var d,e=1/0,f=0,g=c-1,h=0;h<g;h++){var i=new s(b[h],b[h+1]),j=i.length(),k=i.closestPointNormalizedLength(a),l=i.pointAt(k),m=l.squaredDistance(a);m<e&&(e=m,d=f+k*j),f+=j}return d},closestPointNormalizedLength:function(a){var b=this.closestPointLength(a);if(0===b)return 0;var c=this.length();return 0===c?0:b/c},closestPointTangent:function(a){var b=this.closestPointLength(a);return this.tangentAtLength(b)},convexHull:function(){var a,b,c=this.points,d=c.length;if(0===d)return new w;var f;for(a=0;a<d;a++)void 0===f?f=c[a]:c[a].y<f.y?f=c[a]:c[a].y===f.y&&c[a].x>f.x&&(f=c[a]);var g=[];for(a=0;a<d;a++){var h=f.theta(c[a]);0===h&&(h=360);var i=[c[a],a,h];g.push(i)}if(g.sort(function(a,b){var c=a[2]-b[2];return 0===c&&(c=b[1]-a[1]),c}),g.length>2){var j=g[g.length-1];g.unshift(j)}for(var k,l,m,n,o,p,q={},r=[];0!==g.length;)if(k=g.pop(),l=k[0],!q.hasOwnProperty(k[0]+"@@"+k[1]))for(var s=!1;!s;)if(r.length<2)r.push(k),s=!0;else{m=r.pop(),n=m[0],o=r.pop(),p=o[0];var t=p.cross(n,l);if(t<0)r.push(o),r.push(m),r.push(k),s=!0;else if(0===t){var u=1e-10,v=n.angleBetween(p,l);e(v-180)<u?(q[m[0]+"@@"+m[1]]=n,r.push(o)):n.equals(l)||p.equals(n)?(q[m[0]+"@@"+m[1]]=n,r.push(o)):e((v+1)%360-1)<u&&(r.push(o),g.push(m))}else q[m[0]+"@@"+m[1]]=n,r.push(o)}r.length>2&&r.pop();var x,y=-1;for(b=r.length,a=0;a<b;a++){var z=r[a][1];(void 0===x||z<x)&&(x=z,y=a)}var A=[];if(y>0){var B=r.slice(y),C=r.slice(0,y);A=B.concat(C)}else A=r;var D=[];for(b=A.length,a=0;a<b;a++)D.push(A[a][0]);return new w(D)},equals:function(a){if(!a)return!1;var b=this.points,c=a.points,d=b.length;if(c.length!==d)return!1;for(var e=0;e<d;e++){var f=b[e],g=a.points[e];if(!f.equals(g))return!1}return!0},isDifferentiable:function(){var a=this.points,b=a.length;if(0===b)return!1;for(var c=b-1,d=0;d<c;d++){var e=a[d],f=a[d+1],g=new s(e,f);if(g.isDifferentiable())return!0}return!1},length:function(){var a=this.points,b=a.length;if(0===b)return 0;for(var c=0,d=b-1,e=0;e<d;e++)c+=a[e].distance(a[e+1]);return c},pointAt:function(a){var b=this.points,c=b.length;if(0===c)return null;if(1===c)return b[0].clone();if(a<=0)return b[0].clone();if(a>=1)return b[c-1].clone();var d=this.length(),e=d*a;return this.pointAtLength(e)},pointAtLength:function(a){var b=this.points,c=b.length;if(0===c)return null;if(1===c)return b[0].clone();var d=!0;a<0&&(d=!1,a=-a);for(var e=0,f=c-1,g=d?0:f-1;d?g<f:g>=0;d?g++:g--){var h=b[g],i=b[g+1],j=new s(h,i),k=h.distance(i);if(a<=e+k)return j.pointAtLength((d?1:-1)*(a-e));e+=k}var l=d?b[c-1]:b[0];return l.clone()},scale:function(a,b,c){var d=this.points,e=d.length;if(0===e)return this;for(var f=0;f<e;f++)d[f].scale(a,b,c);return this},tangentAt:function(a){var b=this.points,c=b.length;if(0===c)return null;if(1===c)return null;a<0&&(a=0),a>1&&(a=1);var d=this.length(),e=d*a;return this.tangentAtLength(e)},tangentAtLength:function(a){var b=this.points,c=b.length;if(0===c)return null;if(1===c)return null;var d=!0;a<0&&(d=!1,a=-a);for(var e,f=0,g=c-1,h=d?0:g-1;d?h<g:h>=0;d?h++:h--){var i=b[h],j=b[h+1],k=new s(i,j),l=i.distance(j);if(k.isDifferentiable()){if(a<=f+l)return k.tangentAtLength((d?1:-1)*(a-f));e=k}f+=l}if(e){var m=d?1:0;return e.tangentAt(m)}return null},intersectionWithLine:function(a){for(var b=new s(a),c=[],d=this.points,e=0,f=d.length-1;e<f;e++){var g=d[e],h=d[e+1],i=new s(g,h),j=b.intersectionWithLine(i);j&&c.push(j[0])}return c.length>0?c:null},translate:function(a,b){var c=this.points,d=c.length;if(0===d)return this;for(var e=0;e<d;e++)c[e].translate(a,b);return this},serialize:function(){var a=this.points,b=a.length;if(0===b)return"";for(var c="",d=0;d<b;d++){var e=a[d];c+=e.x+","+e.y+" "}return c.trim()},toString:function(){return this.points+""}},Object.defineProperty(w.prototype,"start",{configurable:!0,enumerable:!0,get:function(){var a=this.points,b=a.length;return 0===b?null:this.points[0]}}),Object.defineProperty(w.prototype,"end",{configurable:!0,enumerable:!0,get:function(){var a=this.points,b=a.length;return 0===b?null:this.points[b-1]}}),c.scale={linear:function(a,b,c){var d=a[1]-a[0],e=b[1]-b[0];return(c-a[0])/d*e+b[0]||0}};var x=c.normalizeAngle=function(a){return a%360+(a<0?360:0)},y=c.snapToGrid=function(a,b){return b*l(a/b)},z=c.toDeg=function(a){return 180*a/n%360},A=c.toRad=function(a,b){return b=b||!1,a=b?a:a%360,a*n/180};c.ellipse=c.Ellipse,c.line=c.Line,c.point=c.Point,c.rect=c.Rect;var B={closestPointT:function(a){if(this.closestPointNormalizedLength)return this.closestPointNormalizedLength(a);throw new Error("Neither closestPointT() nor closestPointNormalizedLength() function is implemented.")},isSegment:!0,isSubpathStart:!1,isVisible:!0,nextSegment:null,lengthAtT:function(a){if(a<=0)return 0;var b=this.length();return a>=1?b:b*a},pointAtT:function(a){if(this.pointAt)return this.pointAt(a);throw new Error("Neither pointAtT() nor pointAt() function is implemented.")},previousSegment:null,subpathStartSegment:null,tangentAtT:function(a){if(this.tangentAt)return this.tangentAt(a);throw new Error("Neither tangentAtT() nor tangentAt() function is implemented.")},bbox:function(){throw new Error("Declaration missing for virtual function.")},clone:function(){throw new Error("Declaration missing for virtual function.")},closestPoint:function(){throw new Error("Declaration missing for virtual function.")},closestPointLength:function(){throw new Error("Declaration missing for virtual function.")},closestPointNormalizedLength:function(){throw new Error("Declaration missing for virtual function.")},closestPointTangent:function(){throw new Error("Declaration missing for virtual function.")},equals:function(){throw new Error("Declaration missing for virtual function.")},getSubdivisions:function(){throw new Error("Declaration missing for virtual function.")},isDifferentiable:function(){throw new Error("Declaration missing for virtual function.")},length:function(){throw new Error("Declaration missing for virtual function.")},pointAt:function(){throw new Error("Declaration missing for virtual function.")},pointAtLength:function(){throw new Error("Declaration missing for virtual function.")},scale:function(){throw new Error("Declaration missing for virtual function.")},tangentAt:function(){throw new Error("Declaration missing for virtual function.")},tangentAtLength:function(){throw new Error("Declaration missing for virtual function.")},translate:function(){throw new Error("Declaration missing for virtual function.")},serialize:function(){throw new Error("Declaration missing for virtual function.")},toString:function(){throw new Error("Declaration missing for virtual function.")}},C=function(){for(var b=[],c=arguments.length,d=0;d<c;d++)b.push(arguments[d]);if(!(this instanceof C))return a(C,b);if(0===c)throw new Error("Lineto constructor expects 1 point or 2 coordinates (none provided).");var e;if("string"==typeof b[0]||"number"==typeof b[0]){if(2===c)return this.end=new u(+b[0],+b[1]),this;if(c<2)throw new Error("Lineto constructor expects 1 point or 2 coordinates ("+c+" coordinates provided).");var f;for(e=[],d=0;d<c;d+=2)f=b.slice(d,d+2),e.push(a(C,f));return e}if(1===c)return this.end=new u(b[0]),this;var g;for(e=[],d=0;d<c;d+=1)g=b[d],e.push(new C(g));return e},D={clone:function(){return new C(this.end)},getSubdivisions:function(){return[]},isDifferentiable:function(){return!!this.previousSegment&&!this.start.equals(this.end)},scale:function(a,b,c){return this.end.scale(a,b,c),this},translate:function(a,b){return this.end.translate(a,b),this},type:"L",serialize:function(){var a=this.end;return this.type+" "+a.x+" "+a.y},toString:function(){return this.type+" "+this.start+" "+this.end}};Object.defineProperty(D,"start",{configurable:!0,enumerable:!0,get:function(){if(!this.previousSegment)throw new Error("Missing previous segment. (This segment cannot be the first segment of a path; OR segment has not yet been added to a path.)");return this.previousSegment.end}}),C.prototype=b(B,s.prototype,D);var E=function(){for(var b=[],c=arguments.length,d=0;d<c;d++)b.push(arguments[d]);if(!(this instanceof E))return a(E,b);if(0===c)throw new Error("Curveto constructor expects 3 points or 6 coordinates (none provided).");var e;if("string"==typeof b[0]||"number"==typeof b[0]){if(6===c)return this.controlPoint1=new u(+b[0],+b[1]),this.controlPoint2=new u(+b[2],+b[3]),this.end=new u(+b[4],+b[5]),this;if(c<6)throw new Error("Curveto constructor expects 3 points or 6 coordinates ("+c+" coordinates provided).");var f;for(e=[],d=0;d<c;d+=6)f=b.slice(d,d+6),e.push(a(E,f));return e}if(3===c)return this.controlPoint1=new u(b[0]),this.controlPoint2=new u(b[1]),this.end=new u(b[2]),this;if(c<3)throw new Error("Curveto constructor expects 3 points or 6 coordinates ("+c+" points provided).");var g;for(e=[],d=0;d<c;d+=3)g=b.slice(d,d+3),e.push(a(E,g));return e},F={clone:function(){return new E(this.controlPoint1,this.controlPoint2,this.end)},isDifferentiable:function(){if(!this.previousSegment)return!1;var a=this.start,b=this.controlPoint1,c=this.controlPoint2,d=this.end;return!(a.equals(b)&&b.equals(c)&&c.equals(d))},scale:function(a,b,c){return this.controlPoint1.scale(a,b,c),this.controlPoint2.scale(a,b,c),this.end.scale(a,b,c),this},translate:function(a,b){return this.controlPoint1.translate(a,b),this.controlPoint2.translate(a,b),this.end.translate(a,b),this},type:"C",serialize:function(){var a=this.controlPoint1,b=this.controlPoint2,c=this.end;return this.type+" "+a.x+" "+a.y+" "+b.x+" "+b.y+" "+c.x+" "+c.y},toString:function(){return this.type+" "+this.start+" "+this.controlPoint1+" "+this.controlPoint2+" "+this.end}};Object.defineProperty(F,"start",{configurable:!0,enumerable:!0,get:function(){if(!this.previousSegment)throw new Error("Missing previous segment. (This segment cannot be the first segment of a path; OR segment has not yet been added to a path.)");return this.previousSegment.end}}),E.prototype=b(B,q.prototype,F);var G=function(){for(var b=[],c=arguments.length,d=0;d<c;d++)b.push(arguments[d]);if(!(this instanceof G))return a(G,b);if(0===c)throw new Error("Moveto constructor expects 1 point or 2 coordinates (none provided).");var e;if("string"==typeof b[0]||"number"==typeof b[0]){if(2===c)return this.end=new u(+b[0],+b[1]),this;if(c<2)throw new Error("Moveto constructor expects 1 point or 2 coordinates ("+c+" coordinates provided).");var f;for(e=[],d=0;d<c;d+=2)f=b.slice(d,d+2),0===d?e.push(a(G,f)):e.push(a(C,f));return e}if(1===c)return this.end=new u(b[0]),this;var g;for(e=[],d=0;d<c;d+=1)g=b[d],0===d?e.push(new G(g)):e.push(new C(g));return e},H={bbox:function(){return null},clone:function(){return new G(this.end)},closestPoint:function(){return this.end.clone()},closestPointNormalizedLength:function(){return 0},closestPointLength:function(){return 0},closestPointT:function(){return 1},closestPointTangent:function(){return null},equals:function(a){return this.end.equals(a.end)},getSubdivisions:function(){return[]},isDifferentiable:function(){return!1},isSubpathStart:!0,isVisible:!1,length:function(){return 0},lengthAtT:function(){return 0},pointAt:function(){return this.end.clone()},pointAtLength:function(){return this.end.clone()},pointAtT:function(){return this.end.clone()},scale:function(a,b,c){return this.end.scale(a,b,c),this},tangentAt:function(){return null},tangentAtLength:function(){return null},tangentAtT:function(){return null},translate:function(a,b){return this.end.translate(a,b),this},type:"M",serialize:function(){var a=this.end;return this.type+" "+a.x+" "+a.y},toString:function(){return this.type+" "+this.end}};Object.defineProperty(H,"start",{configurable:!0,enumerable:!0,get:function(){throw new Error("Illegal access. Moveto segments should not need a start property.")}}),G.prototype=b(B,H);var I=function(){for(var b=[],c=arguments.length,d=0;d<c;d++)b.push(arguments[d]);if(!(this instanceof I))return a(I,b);if(c>0)throw new Error("Closepath constructor expects no arguments.");return this},J={clone:function(){return new I},getSubdivisions:function(){return[]},isDifferentiable:function(){return!(!this.previousSegment||!this.subpathStartSegment)&&!this.start.equals(this.end)},scale:function(){return this},translate:function(){return this},type:"Z",serialize:function(){return this.type},toString:function(){return this.type+" "+this.start+" "+this.end}};Object.defineProperty(J,"start",{configurable:!0,enumerable:!0,get:function(){if(!this.previousSegment)throw new Error("Missing previous segment. (This segment cannot be the first segment of a path; OR segment has not yet been added to a path.)");return this.previousSegment.end}}),Object.defineProperty(J,"end",{configurable:!0,enumerable:!0,get:function(){if(!this.subpathStartSegment)throw new Error("Missing subpath start segment. (This segment needs a subpath start segment (e.g. Moveto); OR segment has not yet been added to a path.)");return this.subpathStartSegment.end}}),I.prototype=b(B,s.prototype,J);var K=t.segmentTypes={L:C,C:E,M:G,Z:I,z:I};return t.regexSupportedData=new RegExp("^[\\s\\d"+Object.keys(K).join("")+",.]*$"),t.isDataSupported=function(a){return"string"==typeof a&&this.regexSupportedData.test(a)},c}();

    return g;

}));
