/*! JointJS v2.1.2 (2018-05-08) - JavaScript diagramming library


This Source Code Form is subject to the terms of the Mozilla Public
License, v. 2.0. If a copy of the MPL was not distributed with this
file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/
(function(root, factory) {

    if (typeof define === 'function' && define.amd) {

        // AMD. Register as an anonymous module.
        define(['g'], function(g) {
            return factory(g);
        });

    } else if (typeof exports === 'object') {

        // Node. Does not work with strict CommonJS, but
        // only CommonJS-like environments that support module.exports,
        // like Node.
        var g = require('./geometry');

        module.exports = factory(g);

    } else {

        // Browser globals.
        var g = root.g;

        root.Vectorizer = root.V = factory(g);
    }

}(this, function(g) {

var V,Vectorizer;V=Vectorizer=function(){"use strict";function a(a,b){a||(a={});var c=q("textPath"),d=a.d;if(d&&void 0===a["xlink:href"]){var e=q("path").attr("d",d).appendTo(b.defs());c.attr("xlink:href","#"+e.id)}return q.isObject(a)&&c.attr(a),c.node}function b(a,b,c){c||(c={});for(var d=c.includeAnnotationIndices,e=c.eol,f=c.lineHeight,g=c.baseSize,h=0,i={},j=b.length-1,k=0;k<=j;k++){var l=b[k],m=null;if(q.isObject(l)){var n=l.attrs,o=q("tspan",n),p=o.node,r=l.t;e&&k===j&&(r+=e),p.textContent=r;var s=n.class;s&&o.addClass(s),d&&o.attr("annotations",l.annotations),m=parseFloat(n["font-size"]),void 0===m&&(m=g),m&&m>h&&(h=m)}else e&&k===j&&(l+=e),p=document.createTextNode(l||" "),g&&g>h&&(h=g);a.appendChild(p)}return h&&(i.maxFontSize=h),f?i.lineHeight=f:h&&(i.lineHeight=1.2*h),i}function c(a,b){var c=parseFloat(a);return s.test(a)?c*b:c}function d(a,b,d,e){if(!Array.isArray(b))return 0;var f=b.length;if(!f)return 0;for(var g=b[0],h=c(g.maxFontSize,d)||d,i=0,j=c(e,d),k=1;k<f;k++){g=b[k];var l=c(g.lineHeight,d)||j;i+=l}var m,n=c(g.maxFontSize,d)||d;switch(a){case"middle":m=h/2-.15*n-i/2;break;case"bottom":m=-(.25*n)-i;break;default:case"top":m=.8*h}return m}var e="object"==typeof window&&!(!window.SVGAngle&&!document.implementation.hasFeature("http://www.w3.org/TR/SVG11/feature#BasicStructure","1.1"));if(!e)return function(){throw new Error("SVG is required to use Vectorizer.")};var f={xmlns:"http://www.w3.org/2000/svg",xml:"http://www.w3.org/XML/1998/namespace",xlink:"http://www.w3.org/1999/xlink",xhtml:"http://www.w3.org/1999/xhtml"},h="1.1",i=Math,j=i.PI,k=i.atan2,l=i.sqrt,m=i.min,n=i.max,o=i.cos,p=i.sin,q=function(a,b,c){if(!(this instanceof q))return q.apply(Object.create(q.prototype),arguments);if(a){if(q.isV(a)&&(a=a.node),b=b||{},q.isString(a)){if("svg"===a.toLowerCase())a=q.createSvgDocument();else if("<"===a[0]){var d=q.createSvgDocument(a);if(d.childNodes.length>1){var e,g,h=[];for(e=0,g=d.childNodes.length;e<g;e++){var i=d.childNodes[e];h.push(new q(document.importNode(i,!0)))}return h}a=document.importNode(d.firstChild,!0)}else a=document.createElementNS(f.xmlns,a);q.ensureId(a)}return this.node=a,this.setAttributes(b),c&&this.append(c),this}},r=q.prototype;Object.defineProperty(r,"id",{enumerable:!0,get:function(){return this.node.id},set:function(a){this.node.id=a}}),r.getTransformToElement=function(a){return a=q.toNode(a),a.getScreenCTM().inverse().multiply(this.node.getScreenCTM())},r.transform=function(a,b){var c=this.node;if(q.isUndefined(a))return q.transformStringToMatrix(this.attr("transform"));if(b&&b.absolute)return this.attr("transform",q.matrixToTransformString(a));var d=q.createSVGTransform(a);return c.transform.baseVal.appendItem(d),this},r.translate=function(a,b,c){c=c||{},b=b||0;var d=this.attr("transform")||"",e=q.parseTransformString(d);if(d=e.value,q.isUndefined(a))return e.translate;d=d.replace(/translate\([^\)]*\)/g,"").trim();var f=c.absolute?a:e.translate.tx+a,g=c.absolute?b:e.translate.ty+b,h="translate("+f+","+g+")";return this.attr("transform",(h+" "+d).trim()),this},r.rotate=function(a,b,c,d){d=d||{};var e=this.attr("transform")||"",f=q.parseTransformString(e);if(e=f.value,q.isUndefined(a))return f.rotate;e=e.replace(/rotate\([^\)]*\)/g,"").trim(),a%=360;var g=d.absolute?a:f.rotate.angle+a,h=void 0!==b&&void 0!==c?","+b+","+c:"",i="rotate("+g+h+")";return this.attr("transform",(e+" "+i).trim()),this},r.scale=function(a,b){b=q.isUndefined(b)?a:b;var c=this.attr("transform")||"",d=q.parseTransformString(c);if(c=d.value,q.isUndefined(a))return d.scale;c=c.replace(/scale\([^\)]*\)/g,"").trim();var e="scale("+a+","+b+")";return this.attr("transform",(c+" "+e).trim()),this},r.bbox=function(a,b){var c,d=this.node,e=d.ownerSVGElement;if(!e)return new g.Rect(0,0,0,0);try{c=d.getBBox()}catch(a){c={x:d.clientLeft,y:d.clientTop,width:d.clientWidth,height:d.clientHeight}}if(a)return new g.Rect(c);var f=this.getTransformToElement(b||e);return q.transformRect(c,f)},r.getBBox=function(a){var b,c={},d=this.node,e=d.ownerSVGElement;if(!e)return new g.Rect(0,0,0,0);if(a&&(a.target&&(c.target=q.toNode(a.target)),a.recursive&&(c.recursive=a.recursive)),c.recursive){var f=this.children(),h=f.length;if(0===h)return this.getBBox({target:c.target,recursive:!1});c.target||(c.target=this);for(var i=0;i<h;i++){var j,k=f[i];j=0===k.children().length?k.getBBox({target:c.target,recursive:!1}):k.getBBox({target:c.target,recursive:!0}),b=b?b.union(j):j}return b}try{b=d.getBBox()}catch(a){b={x:d.clientLeft,y:d.clientTop,width:d.clientWidth,height:d.clientHeight}}if(c.target){var l=this.getTransformToElement(c.target);return q.transformRect(b,l)}return new g.Rect(b)};var s=/em$/;r.text=function(c,e){if(c&&"string"!=typeof c)throw new Error("Vectorizer: text() expects the first argument to be a string.");c=q.sanitizeText(c),e||(e={});var f=e.eol,g=e.textPath,h=e.textVerticalAnchor,i="middle"===h||"bottom"===h||"top"===h,j=e.x;void 0===j&&(j=this.attr("x")||0);var k=e.includeAnnotationIndices,l=e.annotations;l&&!q.isArray(l)&&(l=[l]);var m=e.lineHeight,n="auto"===m,o=n?"1.5em":m||"1em";this.empty(),this.attr({"xml:space":"preserve",display:c?null:"none"});var p=parseFloat(this.attr("font-size"));p||(p=16,(i||l)&&this.attr("font-size",p));var r,t=document;g?("string"==typeof g&&(g={d:g}),r=a(g,this)):r=t.createDocumentFragment();for(var u,v=0,w=c.split("\n"),x=[],y=0,z=w.length-1;y<=z;y++){var A,B=o,C="v-line",D=t.createElementNS(q.namespace.xmlns,"tspan"),E=w[y];if(E)if(l){var F=q.annotateString(E,l,{offset:-v,includeAnnotationIndices:k});A=b(D,F,{includeAnnotationIndices:k,eol:y!==z&&f,lineHeight:n?null:o,baseSize:p});var G=A.lineHeight;G&&n&&0!==y&&(B=G),0===y&&(u=.8*A.maxFontSize)}else f&&y!==z&&(E+=f),D.textContent=E;else{D.textContent="-",C+=" v-empty-line";var H=D.style;H.fillOpacity=0,H.strokeOpacity=0,l&&(A={})}A&&x.push(A),y>0&&D.setAttribute("dy",B),(y>0||g)&&D.setAttribute("x",j),D.className.baseVal=C,r.appendChild(D),v+=E.length+1}if(i)if(l)B=d(h,x,p,o);else if("top"===h)B="0.8em";else{var I;switch(z>0?(I=parseFloat(o)||1,I*=z,s.test(o)||(I/=p)):I=0,h){case"middle":B=.3-I/2+"em";break;case"bottom":B=-I-.3+"em"}}else 0===h?B="0em":h?B=h:(B=0,null===this.attr("y")&&this.attr("y",u||"0.8em"));return r.firstChild.setAttribute("dy",B),this.append(r),this},r.removeAttr=function(a){var b=q.qualifyAttr(a),c=this.node;return b.ns?c.hasAttributeNS(b.ns,b.local)&&c.removeAttributeNS(b.ns,b.local):c.hasAttribute(a)&&c.removeAttribute(a),this},r.attr=function(a,b){if(q.isUndefined(a)){for(var c=this.node.attributes,d={},e=0;e<c.length;e++)d[c[e].name]=c[e].value;return d}if(q.isString(a)&&q.isUndefined(b))return this.node.getAttribute(a);if("object"==typeof a)for(var f in a)a.hasOwnProperty(f)&&this.setAttribute(f,a[f]);else this.setAttribute(a,b);return this},r.normalizePath=function(){var a=this.tagName();return"PATH"===a&&this.attr("d",q.normalizePathData(this.attr("d"))),this},r.remove=function(){return this.node.parentNode&&this.node.parentNode.removeChild(this.node),this},r.empty=function(){for(;this.node.firstChild;)this.node.removeChild(this.node.firstChild);return this},r.setAttributes=function(a){for(var b in a)a.hasOwnProperty(b)&&this.setAttribute(b,a[b]);return this},r.append=function(a){q.isArray(a)||(a=[a]);for(var b=0,c=a.length;b<c;b++)this.node.appendChild(q.toNode(a[b]));return this},r.prepend=function(a){var b=this.node.firstChild;return b?q(b).before(a):this.append(a)},r.before=function(a){var b=this.node,c=b.parentNode;if(c){q.isArray(a)||(a=[a]);for(var d=0,e=a.length;d<e;d++)c.insertBefore(q.toNode(a[d]),b)}return this},r.appendTo=function(a){return q.toNode(a).appendChild(this.node),this},r.svg=function(){return this.node instanceof window.SVGSVGElement?this:q(this.node.ownerSVGElement)},r.tagName=function(){return this.node.tagName.toUpperCase()},r.defs=function(){var a=this.svg()||this,b=a.node.getElementsByTagName("defs")[0];return b?q(b):q("defs").appendTo(a)},r.clone=function(){var a=q(this.node.cloneNode(!0));return a.node.id=q.uniqueId(),a},r.findOne=function(a){var b=this.node.querySelector(a);return b?q(b):void 0},r.find=function(a){var b=[],c=this.node.querySelectorAll(a);if(c)for(var d=0;d<c.length;d++)b.push(q(c[d]));return b},r.children=function(){for(var a=this.node.childNodes,b=[],c=0;c<a.length;c++){var d=a[c];1===d.nodeType&&b.push(q(a[c]))}return b},r.index=function(){for(var a=0,b=this.node.previousSibling;b;)1===b.nodeType&&a++,b=b.previousSibling;return a},r.findParentByClass=function(a,b){for(var c=this.node.ownerSVGElement,d=this.node.parentNode;d&&d!==b&&d!==c;){var e=q(d);if(e.hasClass(a))return e;d=d.parentNode}return null},r.contains=function(a){var b=this.node,c=q.toNode(a),d=c&&c.parentNode;return b===d||!!(d&&1===d.nodeType&&16&b.compareDocumentPosition(d))},r.toLocalPoint=function(a,b){var c=this.svg().node,d=c.createSVGPoint();d.x=a,d.y=b;try{var e=d.matrixTransform(c.getScreenCTM().inverse()),f=this.getTransformToElement(c).inverse()}catch(a){return d}return e.matrixTransform(f)},r.translateCenterToPoint=function(a){var b=this.getBBox({target:this.svg()}),c=b.center();return this.translate(a.x-c.x,a.y-c.y),this},r.translateAndAutoOrient=function(a,b,c){var d=this.scale();this.attr("transform",""),this.scale(d.sx,d.sy);var e=this.svg().node,f=this.getBBox({target:c||e}),h=e.createSVGTransform();h.setTranslate(-f.x-f.width/2,-f.y-f.height/2);var i=e.createSVGTransform(),j=new g.Point(a).changeInAngle(a.x-b.x,a.y-b.y,b);i.setRotate(j,0,0);var k=e.createSVGTransform(),l=new g.Point(a).move(b,f.width/2);k.setTranslate(a.x+(a.x-l.x),a.y+(a.y-l.y));var m=this.getTransformToElement(c||e),n=e.createSVGTransform();n.setMatrix(k.matrix.multiply(i.matrix.multiply(h.matrix.multiply(m))));var o=q.decomposeMatrix(n.matrix);return this.translate(o.translateX,o.translateY),this.rotate(o.rotation),this},r.animateAlongPath=function(a,b){b=q.toNode(b);var c=q.ensureId(b),d=q("animateMotion",a),e=q("mpath",{"xlink:href":"#"+c});d.append(e),this.append(d);try{d.node.beginElement()}catch(a){if("fake"===document.documentElement.getAttribute("smiling")){var f=d.node;f.animators=[];var g=f.getAttribute("id");g&&(id2anim[g]=f);for(var h=getTargets(f),i=0,j=h.length;i<j;i++){var k=h[i],l=new Animator(f,k,i);animators.push(l),f.animators[i]=l,l.register()}}}return this},r.hasClass=function(a){return new RegExp("(\\s|^)"+a+"(\\s|$)").test(this.node.getAttribute("class"))},r.addClass=function(a){if(!this.hasClass(a)){var b=this.node.getAttribute("class")||"";this.node.setAttribute("class",(b+" "+a).trim())}return this},r.removeClass=function(a){if(this.hasClass(a)){var b=this.node.getAttribute("class").replace(new RegExp("(\\s|^)"+a+"(\\s|$)","g"),"$2");this.node.setAttribute("class",b)}return this},r.toggleClass=function(a,b){var c=q.isUndefined(b)?this.hasClass(a):!b;return c?this.removeClass(a):this.addClass(a),this},r.sample=function(a){a=a||1;for(var b,c=this.node,d=c.getTotalLength(),e=[],f=0;f<d;)b=c.getPointAtLength(f),e.push({x:b.x,y:b.y,distance:f}),f+=a;return e},r.convertToPath=function(){var a=q("path");a.attr(this.attr());var b=this.convertToPathData();return b&&a.attr("d",b),a},r.convertToPathData=function(){var a=this.tagName();switch(a){case"PATH":return this.attr("d");case"LINE":return q.convertLineToPathData(this.node);case"POLYGON":return q.convertPolygonToPathData(this.node);case"POLYLINE":return q.convertPolylineToPathData(this.node);case"ELLIPSE":return q.convertEllipseToPathData(this.node);case"CIRCLE":return q.convertCircleToPathData(this.node);case"RECT":return q.convertRectToPathData(this.node)}throw new Error(a+" cannot be converted to PATH.")},q.prototype.toGeometryShape=function(){var a,b,c,d,e,f,h,i,j,k,l;switch(this.tagName()){case"RECT":return a=parseFloat(this.attr("x"))||0,b=parseFloat(this.attr("y"))||0,c=parseFloat(this.attr("width"))||0,d=parseFloat(this.attr("height"))||0,new g.Rect(a,b,c,d);case"CIRCLE":return e=parseFloat(this.attr("cx"))||0,f=parseFloat(this.attr("cy"))||0,h=parseFloat(this.attr("r"))||0,new g.Ellipse({x:e,y:f},h,h);case"ELLIPSE":return e=parseFloat(this.attr("cx"))||0,f=parseFloat(this.attr("cy"))||0,i=parseFloat(this.attr("rx"))||0,j=parseFloat(this.attr("ry"))||0,new g.Ellipse({x:e,y:f},i,j);case"POLYLINE":return k=q.getPointsFromSvgNode(this),new g.Polyline(k);case"POLYGON":return k=q.getPointsFromSvgNode(this),k.length>1&&k.push(k[0]),new g.Polyline(k);case"PATH":return l=this.attr("d"),g.Path.isDataSupported(l)||(l=q.normalizePathData(l)),new g.Path(l);case"LINE":return x1=parseFloat(this.attr("x1"))||0,y1=parseFloat(this.attr("y1"))||0,x2=parseFloat(this.attr("x2"))||0,y2=parseFloat(this.attr("y2"))||0,new g.Line({x:x1,y:y1},{x:x2,y:y2})}return this.getBBox()},r.findIntersection=function(a,b){var c=this.svg().node;b=b||c;var d=this.getBBox({target:b}),e=d.center();if(d.intersectionWithLineFromCenterToPoint(a)){var f,h=this.tagName();if("RECT"===h){var i=new g.Rect(parseFloat(this.attr("x")||0),parseFloat(this.attr("y")||0),parseFloat(this.attr("width")),parseFloat(this.attr("height"))),j=this.getTransformToElement(b),k=q.decomposeMatrix(j),l=c.createSVGTransform();l.setRotate(-k.rotation,e.x,e.y);var m=q.transformRect(i,l.matrix.multiply(j));f=new g.Rect(m).intersectionWithLineFromCenterToPoint(a,k.rotation)}else if("PATH"===h||"POLYGON"===h||"POLYLINE"===h||"CIRCLE"===h||"ELLIPSE"===h){var n,o,p,r,s,t,u="PATH"===h?this:this.convertToPath(),v=u.sample(),w=1/0,x=[];for(n=0;n<v.length;n++)o=v[n],p=q.createSVGPoint(o.x,o.y),p=p.matrixTransform(this.getTransformToElement(b)),o=new g.Point(p),r=o.distance(e),s=1.1*o.distance(a),t=r+s,t<w?(w=t,x=[{sample:o,refDistance:s}]):t<w+1&&x.push({sample:o,refDistance:s});x.sort(function(a,b){return a.refDistance-b.refDistance}),x[0]&&(f=x[0].sample)}return f}},r.setAttribute=function(a,b){var c=this.node;if(null===b)return this.removeAttr(a),this;var d=q.qualifyAttr(a);return d.ns?c.setAttributeNS(d.ns,a,b):"id"===a?c.id=b:c.setAttribute(a,b),this},q.createSvgDocument=function(a){var b='<svg xmlns="'+f.xmlns+'" xmlns:xlink="'+f.xlink+'" version="'+h+'">'+(a||"")+"</svg>",c=q.parseXML(b,{async:!1});return c.documentElement},q.idCounter=0,q.uniqueId=function(){return"v-"+ ++q.idCounter},q.toNode=function(a){return q.isV(a)?a.node:a.nodeName&&a||a[0]},q.ensureId=function(a){return a=q.toNode(a),a.id||(a.id=q.uniqueId())},q.sanitizeText=function(a){return(a||"").replace(/ /g,"\xa0")},q.isUndefined=function(a){return"undefined"==typeof a},q.isString=function(a){return"string"==typeof a},q.isObject=function(a){return a&&"object"==typeof a},q.isArray=Array.isArray,q.parseXML=function(a,b){b=b||{};var c;try{var d=new DOMParser;q.isUndefined(b.async)||(d.async=b.async),c=d.parseFromString(a,"text/xml")}catch(a){c=void 0}if(!c||c.getElementsByTagName("parsererror").length)throw new Error("Invalid XML: "+a);return c},q.qualifyAttr=function(a){if(a.indexOf(":")!==-1){var b=a.split(":");return{ns:f[b[0]],local:b[1]}}return{ns:null,local:a}},q.transformRegex=/(\w+)\(([^,)]+),?([^)]+)?\)/gi,q.transformSeparatorRegex=/[ ,]+/,q.transformationListRegex=/^(\w+)\((.*)\)/,q.transformStringToMatrix=function(a){var b=q.createSVGMatrix(),c=a&&a.match(q.transformRegex);if(!c)return b;for(var d=0,e=c.length;d<e;d++){var f=c[d],g=f.match(q.transformationListRegex);if(g){var h,i,j,k,l,m=q.createSVGMatrix(),n=g[2].split(q.transformSeparatorRegex);switch(g[1].toLowerCase()){case"scale":h=parseFloat(n[0]),i=void 0===n[1]?h:parseFloat(n[1]),m=m.scaleNonUniform(h,i);break;case"translate":j=parseFloat(n[0]),k=parseFloat(n[1]),m=m.translate(j,k);break;case"rotate":l=parseFloat(n[0]),j=parseFloat(n[1])||0,k=parseFloat(n[2])||0,m=0!==j||0!==k?m.translate(j,k).rotate(l).translate(-j,-k):m.rotate(l);break;case"skewx":l=parseFloat(n[0]),m=m.skewX(l);break;case"skewy":l=parseFloat(n[0]),m=m.skewY(l);break;case"matrix":m.a=parseFloat(n[0]),m.b=parseFloat(n[1]),m.c=parseFloat(n[2]),m.d=parseFloat(n[3]),m.e=parseFloat(n[4]),m.f=parseFloat(n[5]);break;default:continue}b=b.multiply(m)}}return b},q.matrixToTransformString=function(a){return a||(a=!0),"matrix("+(void 0!==a.a?a.a:1)+","+(void 0!==a.b?a.b:0)+","+(void 0!==a.c?a.c:0)+","+(void 0!==a.d?a.d:1)+","+(void 0!==a.e?a.e:0)+","+(void 0!==a.f?a.f:0)+")"},q.parseTransformString=function(a){var b,c,d;if(a){var e=q.transformSeparatorRegex;if(a.trim().indexOf("matrix")>=0){var f=q.transformStringToMatrix(a),g=q.decomposeMatrix(f);b=[g.translateX,g.translateY],d=[g.scaleX,g.scaleY],c=[g.rotation];var h=[];0===b[0]&&0===b[0]||h.push("translate("+b+")"),1===d[0]&&1===d[1]||h.push("scale("+d+")"),0!==c[0]&&h.push("rotate("+c+")"),a=h.join(" ")}else{var i=a.match(/translate\((.*?)\)/);i&&(b=i[1].split(e));var j=a.match(/rotate\((.*?)\)/);j&&(c=j[1].split(e));var k=a.match(/scale\((.*?)\)/);k&&(d=k[1].split(e))}}var l=d&&d[0]?parseFloat(d[0]):1;return{value:a,translate:{tx:b&&b[0]?parseInt(b[0],10):0,ty:b&&b[1]?parseInt(b[1],10):0},rotate:{angle:c&&c[0]?parseInt(c[0],10):0,cx:c&&c[1]?parseInt(c[1],10):void 0,cy:c&&c[2]?parseInt(c[2],10):void 0},scale:{sx:l,sy:d&&d[1]?parseFloat(d[1]):l}}},q.deltaTransformPoint=function(a,b){var c=b.x*a.a+b.y*a.c+0,d=b.x*a.b+b.y*a.d+0;return{x:c,y:d}},q.decomposeMatrix=function(a){var b=q.deltaTransformPoint(a,{x:0,y:1}),c=q.deltaTransformPoint(a,{x:1,y:0}),d=180/j*k(b.y,b.x)-90,e=180/j*k(c.y,c.x);return{translateX:a.e,translateY:a.f,scaleX:l(a.a*a.a+a.b*a.b),scaleY:l(a.c*a.c+a.d*a.d),skewX:d,skewY:e,rotation:d}},q.matrixToScale=function(a){var b,c,d,e;return a?(b=q.isUndefined(a.a)?1:a.a,e=q.isUndefined(a.d)?1:a.d,c=a.b,d=a.c):b=e=1,{sx:c?l(b*b+c*c):b,sy:d?l(d*d+e*e):e}},q.matrixToRotate=function(a){var b={x:0,y:1};return a&&(b=q.deltaTransformPoint(a,b)),{angle:g.normalizeAngle(g.toDeg(k(b.y,b.x))-90)}},q.matrixToTranslate=function(a){return{tx:a&&a.e||0,ty:a&&a.f||0}},q.isV=function(a){return a instanceof q},q.isVElement=q.isV;var t=q("svg").node;return q.createSVGMatrix=function(a){var b=t.createSVGMatrix();for(var c in a)b[c]=a[c];return b},q.createSVGTransform=function(a){return q.isUndefined(a)?t.createSVGTransform():(a instanceof SVGMatrix||(a=q.createSVGMatrix(a)),t.createSVGTransformFromMatrix(a))},q.createSVGPoint=function(a,b){var c=t.createSVGPoint();return c.x=a,c.y=b,c},q.transformRect=function(a,b){var c=t.createSVGPoint();c.x=a.x,c.y=a.y;var d=c.matrixTransform(b);c.x=a.x+a.width,c.y=a.y;var e=c.matrixTransform(b);c.x=a.x+a.width,c.y=a.y+a.height;var f=c.matrixTransform(b);c.x=a.x,c.y=a.y+a.height;var h=c.matrixTransform(b),i=m(d.x,e.x,f.x,h.x),j=n(d.x,e.x,f.x,h.x),k=m(d.y,e.y,f.y,h.y),l=n(d.y,e.y,f.y,h.y);return new g.Rect(i,k,j-i,l-k)},q.transformPoint=function(a,b){return new g.Point(q.createSVGPoint(a.x,a.y).matrixTransform(b))},q.transformLine=function(a,b){return new g.Line(q.transformPoint(a.start,b),q.transformPoint(a.end,b))},q.transformPolyline=function(a,b){var c=a instanceof g.Polyline?a.points:a;q.isArray(c)||(c=[]);for(var d=[],e=0,f=c.length;e<f;e++)d[e]=q.transformPoint(c[e],b);return new g.Polyline(d)},q.styleToObject=function(a){for(var b={},c=a.split(";"),d=0;d<c.length;d++){var e=c[d],f=e.split("=");b[f[0].trim()]=f[1].trim()}return b},q.createSlicePathData=function(a,b,c,d){var e=2*j-1e-6,f=a,g=b,h=c,i=d,k=(i<h&&(k=h,h=i,i=k),i-h),l=k<j?"0":"1",m=o(h),n=p(h),q=o(i),r=p(i);return k>=e?f?"M0,"+g+"A"+g+","+g+" 0 1,1 0,"+-g+"A"+g+","+g+" 0 1,1 0,"+g+"M0,"+f+"A"+f+","+f+" 0 1,0 0,"+-f+"A"+f+","+f+" 0 1,0 0,"+f+"Z":"M0,"+g+"A"+g+","+g+" 0 1,1 0,"+-g+"A"+g+","+g+" 0 1,1 0,"+g+"Z":f?"M"+g*m+","+g*n+"A"+g+","+g+" 0 "+l+",1 "+g*q+","+g*r+"L"+f*q+","+f*r+"A"+f+","+f+" 0 "+l+",0 "+f*m+","+f*n+"Z":"M"+g*m+","+g*n+"A"+g+","+g+" 0 "+l+",1 "+g*q+","+g*r+"L0,0Z"},q.mergeAttrs=function(a,b){for(var c in b)"class"===c?a[c]=a[c]?a[c]+" "+b[c]:b[c]:"style"===c?q.isObject(a[c])&&q.isObject(b[c])?a[c]=q.mergeAttrs(a[c],b[c]):q.isObject(a[c])?a[c]=q.mergeAttrs(a[c],q.styleToObject(b[c])):q.isObject(b[c])?a[c]=q.mergeAttrs(q.styleToObject(a[c]),b[c]):a[c]=q.mergeAttrs(q.styleToObject(a[c]),q.styleToObject(b[c])):a[c]=b[c];return a},q.annotateString=function(a,b,c){b=b||[],c=c||{};for(var d,e,f,g=c.offset||0,h=[],i=[],j=0;j<a.length;j++){e=i[j]=a[j];for(var k=0;k<b.length;k++){var l=b[k],m=l.start+g,n=l.end+g;j>=m&&j<n&&(q.isObject(e)?e.attrs=q.mergeAttrs(q.mergeAttrs({},e.attrs),l.attrs):e=i[j]={t:a[j],attrs:l.attrs},c.includeAnnotationIndices&&(e.annotations||(e.annotations=[])).push(k))}f=i[j-1],f?q.isObject(e)&&q.isObject(f)?JSON.stringify(e.attrs)===JSON.stringify(f.attrs)?d.t+=e.t:(h.push(d),d=e):q.isObject(e)?(h.push(d),d=e):q.isObject(f)?(h.push(d),d=e):d=(d||"")+e:d=e}return d&&h.push(d),h},q.findAnnotationsAtIndex=function(a,b){var c=[];return a&&a.forEach(function(a){a.start<b&&b<=a.end&&c.push(a)}),c},q.findAnnotationsBetweenIndexes=function(a,b,c){var d=[];return a&&a.forEach(function(a){(b>=a.start&&b<a.end||c>a.start&&c<=a.end||a.start>=b&&a.end<c)&&d.push(a)}),d},q.shiftAnnotations=function(a,b,c){return a&&a.forEach(function(a){a.start<b&&a.end>=b?a.end+=c:a.start>=b&&(a.start+=c,a.end+=c)}),a},q.convertLineToPathData=function(a){a=q(a);var b=["M",a.attr("x1"),a.attr("y1"),"L",a.attr("x2"),a.attr("y2")].join(" ");return b},q.convertPolygonToPathData=function(a){var b=q.getPointsFromSvgNode(a);return 0===b.length?null:q.svgPointsToPath(b)+" Z"},q.convertPolylineToPathData=function(a){var b=q.getPointsFromSvgNode(a);return 0===b.length?null:q.svgPointsToPath(b)},q.svgPointsToPath=function(a){for(var b=0,c=a.length;b<c;b++)a[b]=a[b].x+" "+a[b].y;return"M "+a.join(" L")},q.getPointsFromSvgNode=function(a){a=q.toNode(a);var b=[],c=a.points;if(c)for(var d=0,e=c.numberOfItems;d<e;d++)b.push(c.getItem(d));return b},q.KAPPA=.551784,q.convertCircleToPathData=function(a){a=q(a);var b=parseFloat(a.attr("cx"))||0,c=parseFloat(a.attr("cy"))||0,d=parseFloat(a.attr("r")),e=d*q.KAPPA,f=["M",b,c-d,"C",b+e,c-d,b+d,c-e,b+d,c,"C",b+d,c+e,b+e,c+d,b,c+d,"C",b-e,c+d,b-d,c+e,b-d,c,"C",b-d,c-e,b-e,c-d,b,c-d,"Z"].join(" ");return f},q.convertEllipseToPathData=function(a){a=q(a);var b=parseFloat(a.attr("cx"))||0,c=parseFloat(a.attr("cy"))||0,d=parseFloat(a.attr("rx")),e=parseFloat(a.attr("ry"))||d,f=d*q.KAPPA,g=e*q.KAPPA,h=["M",b,c-e,"C",b+f,c-e,b+d,c-g,b+d,c,"C",b+d,c+g,b+f,c+e,b,c+e,"C",b-f,c+e,b-d,c+g,b-d,c,"C",b-d,c-g,b-f,c-e,b,c-e,"Z"].join(" ");return h},q.convertRectToPathData=function(a){return a=q(a),q.rectToPath({x:parseFloat(a.attr("x"))||0,y:parseFloat(a.attr("y"))||0,width:parseFloat(a.attr("width"))||0,height:parseFloat(a.attr("height"))||0,rx:parseFloat(a.attr("rx"))||0,ry:parseFloat(a.attr("ry"))||0})},q.rectToPath=function(a){var b,c=a.x,d=a.y,e=a.width,f=a.height,g=m(a.rx||a["top-rx"]||0,e/2),h=m(a.rx||a["bottom-rx"]||0,e/2),i=m(a.ry||a["top-ry"]||0,f/2),j=m(a.ry||a["bottom-ry"]||0,f/2);return b=g||h||i||j?["M",c,d+i,"v",f-i-j,"a",h,j,0,0,0,h,j,"h",e-2*h,"a",h,j,0,0,0,h,-j,"v",-(f-j-i),"a",g,i,0,0,0,-g,-i,"h",-(e-2*g),"a",g,i,0,0,0,-g,i,"Z"]:["M",c,d,"H",c+e,"V",d+f,"H",c,"V",d,"Z"],b.join(" ")},q.normalizePathData=function(){function a(a,b,c,d,e,f){var g=1/3,h=2/3;return[g*a+h*c,g*b+h*d,g*e+h*c,g*f+h*d,e,f]}function b(a,c,d,e,f,g,h,i,q,r){var s,t=120*j/180,u=j/180*(+f||0),v=[],w=function(a,b,c){var d=a*l(c)-b*k(c),e=a*k(c)+b*l(c);return{x:d,y:e}};if(r)F=r[0],G=r[1],D=r[2],E=r[3];else{s=w(a,c,-u),a=s.x,c=s.y,s=w(i,q,-u),i=s.x,q=s.y;var x=(a-i)/2,y=(c-q)/2,z=x*x/(d*d)+y*y/(e*e);z>1&&(z=o(z),d*=z,e*=z);var A=d*d,B=e*e,C=(g==h?-1:1)*o(p((A*B-A*y*y-B*x*x)/(A*y*y+B*x*x))),D=C*d*y/e+(a+i)/2,E=C*-e*x/d+(c+q)/2,F=n(((c-E)/e).toFixed(9)),G=n(((q-E)/e).toFixed(9));F=a<D?j-F:F,G=i<D?j-G:G,F<0&&(F=2*j+F),G<0&&(G=2*j+G),(h&&F)>G&&(F-=2*j),(!h&&G)>F&&(G-=2*j)}var H=G-F;if(p(H)>t){var I=G,J=i,K=q;G=F+t*((h&&G)>F?1:-1),i=D+d*l(G),q=E+e*k(G),v=b(i,q,d,e,f,0,h,J,K,[G,I,D,E])}H=G-F;var L=l(F),M=k(F),N=l(G),O=k(G),P=m(H/4),Q=4/3*(d*P),R=4/3*(e*P),S=[a,c],T=[a+Q*M,c-R*L],U=[i+Q*O,q-R*N],V=[i,q];if(T[0]=2*S[0]-T[0],T[1]=2*S[1]-T[1],r)return[T,U,V].concat(v);v=[T,U,V].concat(v).join().split(",");for(var W=[],X=v.length,Y=0;Y<X;Y++)W[Y]=Y%2?w(v[Y-1],v[Y],u).y:w(v[Y],v[Y+1],u).x;return W}function c(a){if(!a)return null;var b={a:7,c:6,h:1,l:2,m:2,q:4,s:4,t:2,v:1,z:0},c=[];return String(a).replace(g,function(a,d,e){var f=[],g=d.toLowerCase();for(e.replace(h,function(a,b){b&&f.push(+b)}),"m"===g&&f.length>2&&(c.push([d].concat(f.splice(0,2))),g="l",d="m"===d?"l":"L");f.length>=b[g]&&(c.push([d].concat(f.splice(0,b[g]))),b[g]););}),c}function d(a){if(Array.isArray(a)&&Array.isArray(a&&a[0])||(a=c(a)),!a||!a.length)return[["M",0,0]];for(var b,d=[],e=0,f=0,g=0,h=0,i=0,j=a.length,k=i;k<j;k++){var l=[];d.push(l);var m=a[k];if(b=m[0],b!=b.toUpperCase()){l[0]=b.toUpperCase();var n,o;switch(l[0]){case"A":l[1]=m[1],l[2]=m[2],l[3]=m[3],l[4]=m[4],l[5]=m[5],l[6]=+m[6]+e,l[7]=+m[7]+f;break;case"V":l[1]=+m[1]+f;break;case"H":l[1]=+m[1]+e;break;case"M":for(g=+m[1]+e,h=+m[2]+f,n=m.length,o=1;o<n;o++)l[o]=+m[o]+(o%2?e:f);break;default:for(n=m.length,o=1;o<n;o++)l[o]=+m[o]+(o%2?e:f)}}else for(var p=m.length,q=0;q<p;q++)l[q]=m[q];switch(l[0]){case"Z":e=+g,f=+h;break;case"H":e=l[1];break;case"V":f=l[1];break;case"M":g=l[l.length-2],h=l[l.length-1],e=l[l.length-2],f=l[l.length-1];break;default:e=l[l.length-2],f=l[l.length-1]}}return d}function e(c){function e(c,d,e){var f,g;if(!c)return["C",d.x,d.y,d.x,d.y,d.x,d.y];switch(c[0]in{T:1,Q:1}||(d.qx=null,d.qy=null),c[0]){case"M":d.X=c[1],d.Y=c[2];break;case"A":c=["C"].concat(b.apply(0,[d.x,d.y].concat(c.slice(1))));break;case"S":"C"===e||"S"===e?(f=2*d.x-d.bx,g=2*d.y-d.by):(f=d.x,g=d.y),c=["C",f,g].concat(c.slice(1));break;case"T":"Q"===e||"T"===e?(d.qx=2*d.x-d.qx,d.qy=2*d.y-d.qy):(d.qx=d.x,d.qy=d.y),c=["C"].concat(a(d.x,d.y,d.qx,d.qy,c[1],c[2]));break;case"Q":d.qx=c[1],d.qy=c[2],c=["C"].concat(a(d.x,d.y,c[1],c[2],c[3],c[4]));break;case"H":c=["L"].concat(c[1],d.y);break;case"V":c=["L"].concat(d.x,c[1]);break;case"L":break;case"Z":}return c}function f(a,b){if(a[b].length>7){a[b].shift();for(var c=a[b];c.length;)i[b]="A",a.splice(b++,0,["C"].concat(c.splice(0,6)));a.splice(b,1),l=g.length}}for(var g=d(c),h={x:0,y:0,bx:0,by:0,X:0,Y:0,qx:null,qy:null},i=[],j="",k="",l=g.length,m=0;m<l;m++){g[m]&&(j=g[m][0]),"C"!==j&&(i[m]=j,m>0&&(k=i[m-1])),g[m]=e(g[m],h,k),"A"!==i[m]&&"C"===j&&(i[m]="C"),f(g,m);var n=g[m],o=n.length;h.x=n[o-2],h.y=n[o-1],h.bx=parseFloat(n[o-4])||h.x,h.by=parseFloat(n[o-3])||h.y}return g[0][0]&&"M"===g[0][0]||g.unshift(["M",0,0]),g}var f="\t\n\v\f\r \xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029",g=new RegExp("([a-z])["+f+",]*((-?\\d*\\.?\\d*(?:e[\\-+]?\\d+)?["+f+"]*,?["+f+"]*)+)","ig"),h=new RegExp("(-?\\d*\\.?\\d*(?:e[\\-+]?\\d+)?)["+f+"]*,?["+f+"]*","ig"),i=Math,j=i.PI,k=i.sin,l=i.cos,m=i.tan,n=i.asin,o=i.sqrt,p=i.abs;return function(a){return e(a).join(",").split(",").join(" ")}}(),q.namespace=f,q}();

    return V;

}));
